  	      subroutine consplot(file,cons,plotf,plotcons,plotgrtin,
     1        LINEWD,NDOTSZ,x1vp,x2vp,y1vp,y2vp,fracvp,hardcopy,
     2        plotnum, plotprob)

! alter program to plot constraints from more then one spacecraft
! to be used with program fakesatg and later versions DWM 6-Aug-91

! introduce split-constraint display                  DWM 21-Aug-91
! introduce radio telescope usage                     DWM 20-Sep-91
! introduce lt grey color and improve plot aesthetics DWM 16-Jun-92

! change from standalone program to a subroutine to be used with
! fakesat_menu                                       DWM 23-Jul-93


	logical cons,plotcons,plotgrt,plotgrtin
	character  plotf*80,file*21,str6*6

      PARAMETER  (MAXT=2500)   !max number of time steps
      PARAMETER  (MAXORB=2)    !max number of orbiters
      PARAMETER  (MAXNST=10)   !max number of tracking stations
      PARAMETER  (MAXST=40)    !max number of GRTs + orbiters
      PARAMETER  (MAXCONS=20)  !max number of spacecraft constraints

! need to check use of isum1 etc more careful used in two places

      real minyz,obsonly,obsrad,maxrad,timerad,timetot,miss,xplot(6)
      real x1vp,x2vp,y1vp,y2vp,fracvp
      real x1,x2,x3,m1,m2,sd1,sd2
      integer ipoint(2)
      double precision tname(MAXNST)
      logical norapcs,apply(MAXCONS,MAXORB),apply0(MAXCONS,MAXORB)
      integer raoption,consnum(MAXORB),NORB,nst
      integer icolor(4+MAXNST+MAXCONS)
      integer isum(4+MAXNST+MAXCONS),isum2(4+MAXNST+MAXCONS)
      integer isum3(4+MAXNST+MAXCONS,MAXORB),ns
      integer isum4(MAXST),isum1(MAXST)
      integer type(MAXST), ground_on(2)
      character consname(4+MAXNST+MAXCONS)*50, number*40,stname(MAXST)*8
      character*80 title(20),oldtitle,titleplot,satname(MAXORB)*8
      character*80 xlabel,xlab1*4,xlab2*3,xlab3*2,xlab4*2,xlab5*2
      character frac*6,frac2*6,frac3*6,frac4*6,char(MAXORB)*1
      character*40 key_text(6,4)
      integer LINEWD,NDOTSZ,num_text(6)
      logical change1(MAXT),change2(MAXT),combined(MAXT)
      real time(MAXT), data(MAXT,4+MAXNST+MAXCONS,MAXORB)
      real alt(MAXT),lost(50,20)
      real yz1(MAXT,MAXNST,MAXORB),TELEMAT(MAXT,MAXORB,MAXNST)
      real conflict(MAXT,40)
      real ra(MAXT),dec(MAXT),ra2(MAXT),dec2(MAXT)
      real num1(MAXT),num2(MAXT)
      real pnum1(50),pnum2(50)
      logical up(MAXT,MAXST,2)
      logical hardcopy,skip,plotnum,plotprob


!	plotcons=.true.
!	plotgrt=.true. 

	plotgrt=.false.
	if(plotgrtin) plotgrt=.true.
	if(plotnum)   plotgrt = .false.
	if(plotprob)  plotgrt = .false.

!	write(*,*) 'plotcons,plotnum,plotgrt: ',plotcons,plotnum,plotgrt


	iwhite=1
	ired=2
        igreen=3
        iblue=4
        icyan=5
        iyellow=7
        iorange=8
        iredmagenta=13
        idkgrey=14
        iltgrey=15

	if(hardcopy) then
	 ictext     = iwhite
	 icaltitude = iwhite
	 if(plotgrt.or.plotcons) then
	 icgreen    = igreen
	 icaltitude = icyan	 
c	 icyellow   = iyellow
	 icyellow   = iorange	 	 
	 else
	 icgreen    = iwhite
	 icgreen    = igreen	 
	 icyellow   = iwhite
	 icyellow   = iorange	 	 	 
	 end if
	else
	 ictext     = iyellow
	 icaltitude = icyan
	 icgreen    = igreen
	 icyellow   = iyellow
c	 icyellow   = iorange	 	 
	end if


	write(*,*) '  '
	write(*,*) 'WARNING: timeline only works for less than 2500 time steps'
	write(*,*) ' '


      	open(1, file=file, status='old')


	if(cons) then
	 isuppress = 0
	else
	 isuppress = 1
	end if 

	
	 read(1,*) NORB
	 read(1,*) ns

	do i=1,ns
	 read(1,'(8a)') stname(i)
	end do

	do IORB=1,NORB

	 read(1,'(a)') satname(IORB)

	 char(IORB)=satname(IORB)(1:1)
      	 read(1, 110)nst, norapcs, raoption
110   	format(i2,l1,i2)
      	 read(1, 111) (tname(i),i = 1,nst)
111 	format(10a8)
      	 read(1, 112) oldtitle
112 	format(a74)

	read(1,*) consnum(IORB)
	read(1,'(20L2)') (apply0(i,IORB),i=1,20)

	do i=1,20
	 if(apply0(i,IORB)) then
	   read(1,'(1x,a)') consname(i)
	 end if
	end do

	if(.not.norapcs) then
	  read(1,*) minyz,obsonly,obsrad,maxrad,timerad,timetot
	end if


       inum = 20 +nst +  4

       consname(inum-3) = '  SPACECRAFT'
       consname(inum-2) = '  TRACKING'
       consname(inum-1) = '  ALL CONSTRAINTS'
       consname(inum) =   '  ALTITUDE'

	end do	! do IORB=1,NORB

      do i = 1,ns
	type(i) = 1
	do IORB=1,NORB
	 if (stname(i).eq.satname(IORB)) type(i) = 2
	end do
      end do



          

	 title(1)='RA: Opt1: (All-RNE)+RNE at same time:NO ROT:' 
	 title(2)='RA: Opt2: 21/24 RNE: NO ROT'
	 title(3)='RA: Opt3: 21/24 RNE: ROT during NO obs'
	 title(4)='RA: Opt4: NO RNE: NO ROT'
	 title(5)='RA: Opt5: 21/24 RNE: continuous ROT'

	do IORB=1,NORB
	 title(5+IORB)='CONSTRAINT PLOT FOR '//satname(IORB)
	end do
 


      number = '123456789'

      do i = 1,nst
      	write(consname(20 + i)(1:50), 210) tname(i)
!210 	format(17htracking station ,a8,25x)
210 	format(2x,a8,40x)
      end do

  


   	if(.not.norapcs) miss=obsonly-(timetot-timerad)

	if(.not.norapcs) then
	 write(*,*) minyz,obsonly,obsrad,maxrad,timerad,timetot
	end if


	ispace=20+nst+1
	itotal=20+nst+3

C	write(*,*) 'ispace, itotal', ispace, itotal

      ierr = 0
      ix = 0


  101 continue

      if (ierr.eq.0) then

       ix = ix + 1

       if (ierr.eq.0) read(1, *, iostat=ierr) IY,ID,IH,IM,IS
	time(ix)=float(ID)+float(IH)/24.0+float(IM)/1440.0
     1          +float(IS)/86400.0 

	if(ix.eq.1) time0=float(ID)

	time(ix)=time(ix)-time0


	if(ix.eq.1) then
	  IYREF=IY
	  IDREF=ID
	  IHREF=0
	  IMREF=0
	  ISREF=0
	write(xlab1,'(i4)') IYREF
	write(xlab2,'(i3)') IDREF
	write(xlab3,'(i2)') IHREF
	write(xlab4,'(i2)') IMREF
	write(xlab5,'(i2)') ISREF


	xlabel='Time (hours) from 0 UT on  day '//xlab2//
     1  ' of '//xlab1


	 end if


	 
        if (ierr .eq. 0) then
	 if(.not.norapcs) then
	   read(1, *, iostat=ierr) angyz,(data(ix,j,1),j = 1,inum)
	 else
	  do IORB=1,NORB
	   read(1, *, iostat=ierr) (yz1(ix,j,IORB),j = 1,nst)
	   read(1, *, iostat=ierr) (data(ix,j,IORB),j = 1,inum)
	  end do
	  do IORB=1,NORB
	  read(1, *, iostat=ierr) (TELEMAT(ix,IORB,IST),IST = 1,nst)
	  end do

	  do k=1,2
	  read(1,*) (up(ix,j,k),j=1,ns)
	  end do

	if(plotnum.or.plotprob) then

! determine number of telescopes that can observe at any given time
! num1 = if spacecraft can observe: number of telescopes including spacecraft
!        else it is zero
! num2 = number of ground radio telescopes
! assumes
! (1) only one spacecraft
! (2) spacecraft is first element in list
!
! pnum2(n) is the fraction of the time that at n ground radio telescopes
! are available
!
! pnum1(n) is defined in a similar fashion
! 
! DWM 6-May-94

	  num1(ix) = 0.0
	  num2(ix) = 0.0



	 do j=2,ns
	  if(up(ix,j,1)) num2(ix) = num2(ix) + 1.0
	 end do

	  if(up(ix,1,1)) num1(ix) = num2(ix) + 1.0

	if(plotprob) then

	  if(ix.eq.1) then
	   do k=1,ns
	    pnum1(k)=0.0
	    pnum2(k)=0.0
	   end do
	  end if

	  in1 = int(num1(ix) + 0.1)	
	  in2 = int(num2(ix) + 0.1)

	  if(in1.gt.0) then
	   do k=1,in1
	     pnum1(k) = pnum1(k) + 1.0
	   end do
	  end if 

	  if(in2.gt.0) then
	   do k=1,in2
	     pnum2(k) = pnum2(k) + 1.0
	   end do
	  end if 

	end if 

	if(ix.eq.1) then
	  m1 = 0.0
	  m2 = 0.0
	  sd1 = 0.0
	  sd2 = 0.0
	end if

	 m1  = m1 + num1(ix)		
	 m2  = m2 + num2(ix)
	 sd1 = sd1 + (num1(ix)**2)		
	 sd2 = sd2 + (num2(ix)**2)				

	end if !if(plotnum.or.plotprob)


	
	  if(NORB.eq.1) then
	  read(1,*) ra(ix),dec(ix)
	  ra(ix)=0.0
	  dec(ix)=0.0
	  else
	  read(1,*) ra(ix),dec(ix),ra2(ix),dec2(ix)
	  end if
         end if
 	end if





	           
		 if(.not.norapcs) then		 
	  	   if(raoption.eq.1) then
                    if(data(ix,6,1).gt.0.5) then
                    if(data(ix,itotal,1).lt.0.5) data(ix,itotal,1)=-1.0
 	            if(data(ix,ispace,1).lt.0.5) data(ix,ispace,1)=-1.0
	            end if
	           end if

	           if(raoption.eq.2) then
	            if(maxradin.lt.timerad) then
                     if(data(ix,itotal,1).lt.0.5) data(ix,itotal,1)=-1.0
 	             if(data(ix,ispace,1).lt.0.5) data(ix,ispace,1)=-1.0
                     end if
	            end if
                 

	           if(raoption.eq.3) then
                    if(data(ix,6,1).gt.0.5) then
                     if(data(ix,itotal,1).lt.0.5) then
                        if(miss.gt.0.5) then
                          data(ix,6,1)=-1.0
                          data(ix,itotal,1)=-1.0
 	                  data(ix,ispace,1)=-1.0
                          miss=miss-1.0
	                end if
		      else
	                data(ix,6,1)=-1.0
	              end if
		     end if
		    end if
		
C		  write(*,*) 'miss ',miss
	             

	           if(raoption.eq.4) then
                    data(ix,6,1)=0.0
	           end if


	           if(raoption.eq.5) then
                    if(data(ix,6,1).gt.0.5) then
                     if(data(ix,itotal,1).lt.0.5) then
                        if(miss.gt.0.5) then
                          data(ix,6,1)=-1.0
                          data(ix,itotal,1)=-1.0
 	                  data(ix,ispace,1)=-1.0
                          miss=miss-1.0
	                end if
		      else
	                data(ix,6,1)=-1.0
	              end if
		     end if
		    end if

	      end if
		




	end if
	             


	
      if (ierr .eq. 0) goto 101

      t1 = time(1)
      ix=ix-1

! determine mean and standard devitations

!	write(*,*) 'm1,m2,sd1,sd2,ix: ',m1,m2,sd1,sd2,ix

	m1 = m1/float(ix)
	m2 = m2/float(ix)

	sd1 = sqrt((sd1/float(ix)) - (m1**2))
	sd2 = sqrt((sd2/float(ix)) - (m2**2))

!	write(*,*) 'm1,m2,sd1,sd2: ',m1,m2,sd1,sd2



	if(ix.gt.MAXT) goto 5000



      do i = 1, ix
      	time(i) = 24.0 * time(i)
      end do

	 dt=time(2)-time(1)

      	xmin0 = time(1)
      	xmax0 = time(ix)
	xmin  = xmin0
	xmax  = xmax0

	 dr=3.1415926/180.0
	 angcrit=0.1 !degrees
	 angcrit=angcrit*dr !radians
	 cosang=cos(angcrit)

	do i=1,ix

	if(i.gt.1) then

         f1=cos(dr*dec(i))*cos(dr*dec(i-1))*cos(dr*15.0*(ra(i)-ra(i-1)))
	     f2=sin(dr*dec(i))*sin(dr*dec(i-1))


	 f3=f1+f2


	  if(f3.le.cosang) then
	     change1(i)=.true.
	  else
	     change1(i)=.false.
	  end if



	  if(NORB.ne.1) then

         f1=cos(dr*dec2(i))*cos(dr*dec2(i-1))
     1      *cos(dr*15.0*(ra2(i)-ra2(i-1)))
	      f2=sin(dr*dec2(i))*sin(dr*dec2(i-1))

	      f3=f1+f2

	  if(f3.le.cosang) then
	      change2(i)=.true.
	   else
	      change2(i)=.false.
	   end if

	  end if

	else

	      change1(i)=.false.
 	      change2(i)=.false.
	end if

	 if(NORB.ne.1) then
        f1=cos(dr*dec(i))*cos(dr*dec2(i))*cos(dr*15.0*(ra(i)-ra2(i)))
	    f2=sin(dr*dec(i))*sin(dr*dec2(i))
	    f3=f1+f2

	  if(f3.ge.cosang) then
	    combined(i)=.true.
	  else
	    combined(i)=.false.
	  end if


	end if


	end do




300	continue

	   ioneplot=0

!	   dy=0.45
	   dy=0.35

	if(NORB.gt.1) then

!	write(*,*) 'Combine multiple spacecraft data onto single plot ?'
!	write(*,*) '(1=yes)'
!	read(*,*) ioneplot

	ioneplot = 0

	


	if(ioneplot.eq.1) then
	 if(isuppress.ne.1) then
	 write(*,*) 'suppress ploting of spaceraft constraints'
           isuppress=1
	  end if
	 end if
	end if

!	write(*,*) 'Suppress plotting of TRACKING and SPACECRAFT lines ?'
!	write(*,*) '(1=yes)'
!	read(*,*) isuppress2

	isuppress2 = 1

	

	do IORB=1,NORB

	do i=1,20
	 if(isuppress.eq.1) then
	   apply(i,IORB)=.false.
	 else
	   apply(i,IORB)=apply0(i,IORB)
	 end if
	end do

	 do i=21,inum
	  apply(i,IORB)=.true.
	 end do

	if(isuppress2.eq.1) then
	 apply(inum-2,IORB)=.false.
	 apply(inum-3,IORB)=.false.
	end if

	end do ! do IORB=1,NORB


200	continue

!	write(*,*) 'timerange (hr) for plot now set to:'
!	write(*,*) xmin,xmax
!	write(*,*) 'Range of times in data set is:'
!	write(*,*) xmin0,xmax0

! add this line to turn off ixchange  DWM 23JUL93:

	 ixchange = 0

!	if(ixchange.eq.0) then
!	 write(*,*) 'Change range of times to be ploted ? (1=yes)'
!	 read(*,*) ixchange
!	end if

	if(ixchange.eq.1) then
	  write(*,*) 'what is min and max time (hr) to be ploted ?'
	  read(*,*) xmin1
	  read(*,*) xmax1
	 do i=1,ix
	  if(i.eq.1) then
	    xmin=time(i)
	    xmax=time(i)
	    sqmin0=(xmin1-xmin)**2
	    sqmax0=(xmax1-xmax)**2
	  else
	    sqmin=(xmin1-time(i))**2
	    sqmax=(xmax1-time(i))**2
	   if(sqmin.lt.sqmin0) then
	     sqmin0=sqmin
	     xmin=time(i)
	   end if	   
	   if(sqmax.lt.sqmax0) then
	     sqmax0=sqmax
	     xmax=time(i)
	   end if
	  end if
!	 write(*,*) 'i,sqmin0,sqmin,xmin1,xmin',i,sqmin0,sqmin,xmin1,xmin
	 end do	
         write(*,*) 'nearest min and max to times selected are:'
	 write(*,*) xmin,xmax 
	end if

	ixrange=0

	dt=time(2)-time(1)

! with postscript files there was a problem of white lines appearing at
! random in plot. 

	dt=1.005*dt 

	xminplot=xmin-0.5*dt
	xmaxplot=xmax+0.5*dt

	do i=1,ix
	 if(time(i).ge.xmin.and.time(i).le.xmax) then
	  ixrange=ixrange+1
	 end if
	end do


100 	continue

	
!	xleft   =0.05
!	xright  =0.95
!	ybottom =0.07	
!       ytop    =0.95

	xleft   = 0.0
	xright  = 1.0
	ybottom = 0.0	
        ytop    = 1.0


! alpha=ratio of Left most plot to total width
! beta=ratio of Right most plot to total width

	alpha=0.28
	beta=0.1

	xplot(1)=xleft
	xplot(6)=xright
	xplot(2)=xleft+alpha*(xright-xleft)
	xplot(3)=xplot(2)
	xplot(5)=xplot(6)-beta*(xright-xleft)
	xplot(4)=xplot(5)

! introduce key to right of main plot
! gamma = fraction of plot width occupied by key

	gamma = 0.1

	do i=1,6
	 xplot(i) = xplot(1) + (1.0-gamma)*(xplot(i)-xplot(1))
	end do
		
!       if(isuppress.eq.1) then
!        write(*,*) 'Plot telemetry station usage ? (1=yes)'
!      else
!        write(*,*) 'Plot constraints and telemetry station usage ?' 
!	write(*,*) '(1=yes)'
!      end if

!       read(*,*) iplot

	iplot = 1

!     if(iplot.eq.1) then

!       call pgbegin(20, plotf, 1, 1)
!       call pgbegin(20, plotf, 1, 2)

	call pgbbuf

        CALL PGSLW(LINEWD)

      if(plotnum.or.plotprob) then

	ysplit = 0.8 

	if(plotnum) then

	y2 = ybottom + ysplit*(ytop-ybottom)
	y3 = ybottom + 0.5*(y2-ybottom)

      yns = float(ns) + 1.0

!      write(*,*) 'yns: ',yns
!      write(*,*) 'ix: ',ix

        call pgvport3(xplot(1),xplot(6),ybottom,y3,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)






      call pgsci(iwhite)
      call pgwindow(xminplot,xmaxplot,0.0,yns)

      if(xmaxplot-xminplot.lt.1.) then
      xtick=0.1      
      else if(xmaxplot-xminplot.lt.6.) then      
      xtick=0.5
      else if(xmaxplot-xminplot.lt.12.) then      
      xtick=1.0
      else if(xmaxplot-xminplot.lt.28.) then
      xtick=2.
      else  if(xmaxplot-xminplot.lt.50.) then
      xtick=4.
      else  if(xmaxplot-xminplot.lt.100.) then
      xtick=8.
      else  if(xmaxplot-xminplot.lt.200.) then
      xtick=20.      
      else  if(xmaxplot-xminplot.lt.500.) then
      xtick=50.
      else  if(xmaxplot-xminplot.lt.700.) then
      xtick=100.
      else  
      xtick=200.      
      endif            
c      call pgbox('bcnist',2.0,2,'bcnst',0.0,0)
      call pgbox('bcnist',xtick,2,'bcnst',0.0,0)
      call pgsci(ictext)
      call pglabel(xlabel,'Number',' ')
      call pgsci(icyellow)
      call pgsls(2)
      call pgline(ix,time,num2)
      call pgsls(1)

   

        call pgvport3(xplot(1),xplot(6),y3,y2,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)



      call pgsci(iwhite)
      call pgwindow(xminplot,xmaxplot,0.0,yns)


c      call pgbox('bcist',2.0,2,'bcnst',0.0,0)
      call pgbox('bcist',xtick,2,'bcnst',0.0,0)      
      call pgsci(ictext)
      call pglabel(' ','Number',' ')
      call pgsci(icgreen)
      call pgsls(1)
      call pgline(ix,time,num1)
      call pgsls(1)

 
        call pgvport3(xplot(1),xplot(6),y2,ytop,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)

      do i = 1, ix
      	alt(i) = data(i,inum,1) 
      end do


      call pgsci(iwhite)
      call pgwindow(xminplot,xmaxplot,-0.2,1.2)
c      call pgbox('bc',2.0,2,'bc',0.0,0)



      call pgbox('bc',xtick,2,'bc',0.0,0)      
c      call pgsci(ictext)
      call pgsci(iwhite)      
      call pglabel(' ','Altitude','Number of Telescopes Available ')
      call pgsci(icaltitude)
      call pgline(ix,time,alt)

	else

	do i=1,ns
	  pnum1(i)=pnum1(i)/float(ix)
	  pnum2(i)=pnum2(i)/float(ix)
!	  write(*,*) 'i,pnum1,pnum2: ',i,pnum1(i),pnum2	(i)
       end do

        call pgvport3(xplot(1),xplot(6),ybottom,ytop,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)

      call pgsci(iwhite)
      x1 = 0.0
      x2 = float(ns)      
      call pgwindow(x1,x2,0.0,1.0)
      call pgbox('bgcnt',1.0,1,'bgcnst',0.10,1)
      call pgsci(ictext)
      call pglabel('N: Number of Telescopes ',
     1    'Fraction of the time at least N available',
     2    'Telescope Availability ')


        call pgsci(icgreen)
	ipoint(1) = 13
        call pgmove(0.0,1.0)
	x = 0.0
        dx = 1.0

	do i=1,ns
	 x = x + dx
	 call pgsls(1)
	 call pgdraw(x,pnum1(i))
	 call pgsch(2.0)
	 call pgpoint(1,x,pnum1(i),ipoint(1))
	 call pgsch(1.0)
	end do




        call pgsci(icyellow)
	ipoint(2) = 18
        call pgmove(0.0,1.0)
	x = 0.0
        dx = 1.0

	do i=1,ns
	 x = x + dx
	 call pgsls(2)
	 call pgdraw(x,pnum2(i))
	 call pgsch(2.0)
	 call pgpoint(1,x,pnum2(i),ipoint(2))
	 call pgsch(1.0)
	end do

	call pgsls(1)



	end if



      end if

      if(plotcons) then

!      call pgbegin(20, plotf, 1, 1)


      call pgask(.true.)


	do IORB=1,NORB

      	ymin = 0.0

	if(isuppress.eq.1) then
	 if(isuppress2.eq.1) then  
	  ymax=float(nst+4-2) + 1.5
	 else
	  ymax=float(nst+4) + 1.5
	 end if
	else
	 if(isuppress2.eq.1) then
	  ymax = float(consnum(IORB)+nst+4-2) + 1.5
	 else
	  ymax = float(consnum(IORB)+nst+4) + 1.5
	 end if
	end if



      	ij = 0


	if(norapcs) then
	  titleplot=title(5+IORB)
	else
	 titleplot=title(raoption)
	end if

	if(ioneplot.eq.1) then
!         titleplot='CONSTRAINT PLOT FOR '// 
!     1     satname(1)//'(=1) and '//satname(2)//'(=2)'
         titleplot='CONSTRAINT PLOT FOR '// 
     1     satname(1)//'(='//char(1)//' ) and '//
     2     satname(2)//'(='//char(2)//' )'
	else
!	 call pgadvance
	end if

!      call pgsci(iwhite)

! Plot constraint names

!     call pgbbuf

!       call pgvport(xplot(1),xplot(2),ybottom,ytop)
        call pgvport3(xplot(1),xplot(2),ybottom,ytop,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)


      call pgwindow(xmin,xmax,0.5,ymax)
      call pgbox('bc',0.0,0.0,'bc',1.0,0.0)
!     call pgsci(iwhite)
!     call pgsch(0.5)
      call pgsch(0.9)

	   y = 0

	call pgsci(ictext)


      do j = 1, inum-1

!	 if(inum.le.20) then
!	   call pgsch(0.8)
!	 else
!	   call pgsch(1.0)
!	 end if

	 call pgsch(20.0/float(inum))


	if(apply(j,IORB)) then
      	    y = y+1.0
      	   xl = xmin + (0.02 * (xmax - xmin))
!      	   call pgtext(xl, y + 0.2, consname(j))
	   dy_text = 0.1
	   y_text = y - dy_text
      	   call pgtext(xl, y_text , consname(j))
      	   isum(j) = 0
	   isum2(j)=0
	   isum3(j,IORB)=0 
	 end if

	end do


      	y = y +1.0

      	call pgtext(xl, y, consname(inum))

!	call pgsch(1.0)

	call pgsci(iwhite)


! Plot constraints

!      call pgvport(xplot(3),xplot(4),ybottom,ytop)
       call pgvport3(xplot(3),xplot(4),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)
      call pgwindow(xminplot,xmaxplot,0.5,ymax+1.0)      
      call pgsci(ictext)
      call pglabel(xlabel,' ',titleplot)
      call pgwindow(xminplot,xmaxplot,0.5,ymax)      
      call pgsci(iwhite)      
!     call pgbox('gbcnst',0.0,0.0,'bc',1.0,0.0)
      if(xmaxplot-xminplot.lt.1.) then
      xtick=0.1      
      else if(xmaxplot-xminplot.lt.6.) then      
      xtick=0.5
      else if(xmaxplot-xminplot.lt.12.) then      
      xtick=1.0
      else if(xmaxplot-xminplot.lt.28.) then
      xtick=2.
      else  if(xmaxplot-xminplot.lt.50.) then
      xtick=4.
      else  if(xmaxplot-xminplot.lt.100.) then
      xtick=8.
      else  if(xmaxplot-xminplot.lt.200.) then
      xtick=20.      
      else  if(xmaxplot-xminplot.lt.500.) then
      xtick=50.
      else  if(xmaxplot-xminplot.lt.700.) then
      xtick=100.
      else  
      xtick=200.      
      endif            
      call pgbox('gbcnmist',xtick,2,'bc',1.0,0)
!     call pgsch(0.7)
      call pgsch(0.7)

c      call pgsci(ictext)
c      call pglabel(xlabel,' ',titleplot)
      call pgsci(iwhite)

!     call pgslw(1)


	 y=0

       do j = 1, inum-1
	 lost(j,IORB)=0.0
	do i=1,ix
	   conflict(i,j)=0.0
	end do
       end do

	jfound=0

      do j = 1, inum-1

	if(apply(j,IORB)) then

      	y = y+1.0

!      	xl = xmin + (0.02 * (xmax - xmin))
!      	 call pgsch(0.5)
!        call pgsci(icaltitude)
!      	call pgtext(xl, y + 0.2, consname(j))
!      	isum(j) = 0
!	isum2(j)=0



       do i = 1, ix

	if(time(i).ge.xmin.and.time(i).le.xmax) then



! color scheme of tracking station viewperiods:
! green   => Tracking station that tracked spacecraft
! yellow  => Tracking station could have tracked spacecraft
! lt grey => Spacecraft tracking conflict prevented this spacecraft
!            from being tracked by this tracking station
! red    => Spacecraft tracking conflict prevented this spacecraft
!           from being tracked at this epoch
! white  => spacecraft visible from tracking station but spacecraft
!           constraints are broken

!	 icgreen =3
!        icyellow=7
!        ired   =2
!        iwhite =1
!        iltgrey=15

	 icolor(j)=icgreen

	  
	if(j.gt.20.and.j.le.(20+nst)) then

	 icolor(j)=iwhite

	 if(yz1(i,j-20,IORB).gt.-0.1) then
!	 if(data(i,21+nst,IORB) .lt. 0.5) then 
!	 if(data(i,j,IORB) .lt. 0.5) then	
	  if(TELEMAT(i,IORB,j-20).eq.0.0) then
	   icolor(j)=icyellow
	  else
	   icolor(j)=icgreen
	  end if
!	 end if
!	 end if
	 end if

	 if(icolor(j).eq.icyellow) then

	  do i1=1,NORB
	   if(i1.ne.IORB) then
	     conflict(i,j)=conflict(i,j)+TELEMAT(i,i1,j-20)
	   end if
	  end do

	  if(conflict(i,j).gt.0.0) then

!	   icolor(j)=ired

	   icolor(j)=ired

	  do j1=1,nst
	   if(TELEMAT(i,IORB,j1).gt.0.0) then
	    icolor(j)=iltgrey
	   end if
	  end do


           lost(j,IORB)=1.0+lost(j,IORB)

	  end if

	 end if

	end if

	 if(j.eq.(23+nst).or.j.eq.(22+nst)) then
	   if(data(i,23+nst,IORB).lt.0.5) then
	    icolor(j)=ired
	   else
	    icolor(j)=iwhite
	   end if 
	  do j1=1,nst
	   if(TELEMAT(i,IORB,j1).gt.0.0) then
	    icolor(j)=icgreen
	   end if
	  end do
	 end if

	 if(j.eq.(23+nst)) then
	   if(data(i,j,IORB).lt.0.5) then
	    if(icolor(j).eq.ired) then
	     lost(j,IORB)=1.0+lost(j,IORB)
	    end if
	   end if
	 end if

	 if(j.eq.(22+nst)) then
	   if(data(i,23+nst,IORB).lt.0.5) then
	    if(icolor(j).eq.ired) then
	     lost(j,IORB)=1.0+lost(j,IORB)
	    end if
	   end if
	 end if

	 

	iline=1

      	 x = time(i)

         if (i .eq. 1) call pgmove(x, y)

      	if (data(i,j,IORB) .gt. 0.5) then
      	 call pgmove(x, y)
      	else
	  if(data(i,j,IORB).gt.-0.5) then
     	   isum(j) = isum(j) + 1
	  else
   	   isum2(j) = isum2(j)+1
	   iline=4
	  end if

	 if(j.le.20) then
	  if(data(i,j,IORB).lt.0.5) then
     	   isum3(j,IORB) = isum3(j,IORB) + 1
	  end if
	 end if


	if(j.ge.21.and.j.le.20+nst) then
	 if(TELEMAT(i,IORB,j-20).gt.0.0) then
     	   isum3(j,IORB) = isum3(j,IORB) + 1
	   jfound=jfound+1
	 end if
	end if

	if(j.eq.21+nst) then
	  if(data(i,j,IORB).lt.0.5) then
     	   isum3(j,IORB) = isum3(j,IORB) + 1
	  end if
	end if

	if(j.eq.22+nst.or.j.eq.23+nst) then
	    iadd=0
	 do j1=21,20+nst
     	   iadd = iadd + isum3(j1,IORB)
	 end do
	   isum3(j,IORB)=iadd
	end if

!	write(*,*) 'IORB,j,isum3(j,IORB) ',IORB,j,isum3(j,IORB) 



	 call pgsls(iline)
         call pgsci(icolor(j))
!        call pgdraw(x, y)

! there is a bug in the software that produced dark lines thru consplot
! diagram at a few epochs. This needs more investigations but the following
! is a quick fix hopefully. DWM 8-Aug-91

!	 xrect1=x-dt
!	 xrect1=time(i-1)
!	 xrect2=x


	  xrect1=time(i)-0.5*dt
	  xrect2=time(i)+0.5*dt

	 if(ioneplot.ne.1) then
	  yrect1=y-dy
	  yrect2=y+dy
	 else
	  yrect1=y-0.5+(float(IORB-1)/float(NORB))
	  yrect2=yrect1+1/(float(NORB))
	  yrect1=yrect1+(0.5-dy)
	  yrect2=yrect2-(0.5-dy)
	 end if

	 call pgrect(xrect1,xrect2,yrect1,yrect2) 

       	end if

	end if ! i=1,ix ?

       end do

	end if
      end do

!	call pgslw(2)

      do i = 1, ix
      	alt(i) = data(i,inum,IORB) + 1+y
      end do

	call pgsci(icaltitude)  
      	call pgline(ix, time, alt)
	call pgsci(iwhite)


	y = -1.0

!	call pgslw(5)

      do j = 1, inum

	if(apply(j,IORB)) then

      	y = y+1.0

       do i = 1, ix

	if(time(i).ge.xmin.and.time(i).le.xmax) then

! crude method for source changes

	  xrect1=time(i)
	  xrect2=time(i+1)

	 if(ioneplot.ne.1) then
	  yrect1=y-0.5
	  yrect2=y+0.5
	 else
	  yrect1=y-0.5+(float(IORB-1)/float(NORB))
	  yrect2=yrect1+1/(float(NORB))
	 end if

	if(IORB.eq.1.and.change1(i)) then
	  call pgsci(ired)
	  call pgmove(time(i),yrect1)	
	  call pgdraw(time(i),yrect2)
	end if

	if(IORB.eq.2.and.change2(i)) then
	  call pgsci(ired)
	  call pgmove(time(i),yrect1)	
	  call pgdraw(time(i),yrect2)
	end if

	  end if
	 end do
	end if
	end do	 	 





! Plot Percentages

!     call pgslw(1)

      call pgsci(iwhite)

!      call pgvport(xplot(5),xplot(6),ybottom,ytop)  
       call pgvport3(xplot(5),xplot(6),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)

      call pgwindow(xmin,xmax,0.5,ymax)
      call pgbox('bc',0.0,0.0,'bc',1.0,0.0)
      call pgsls(1)
!      call pgsci(icaltitude)
!      call pgsch(0.5)
      call pgsci(iwhite)
      call pgsch(1.0)

      call pgsch(20.0/float(inum))


	   y = 0

      do j = 1, inum-1

	
	if(apply(j,IORB)) then

	  y = y + 1.0

      	 percent = (float(isum(j)) * 100.) / float(ixrange)
      	 percent3 = (float(isum3(j,IORB)) * 100.) / float(ixrange)
!        call pgsci(icyellow)
    	 write(frac(:5), '(f5.1)') percent
	 frac=frac(:5)//'%'    	 
         write(frac3(:5), '(f5.1)') percent3
	 frac3=frac3(:5)//'%'

C	write(*,*) 'j ',j

	if(apply(6,IORB)) then
		j1=6
	        j2=inum-1
	        j3=inum-3
	 if((j.eq.j1).or.(j.eq.j2).or.(j.eq.j3)) then
    	  percent2 = (real(isum2(j)) * 100.) / real(ixrange)
     	  write(frac2(:5), '(f5.1)') percent2
	  frac2=frac2(:5)//'%'
!   	  xr2 = xmin + (0.92 * (xmax - xmin))
   	  xr2 = xmin + (0.5 * (xmax - xmin))
!         call pgsci(icyellow)
!     	  call pgtext(xr2, y + 0.3, frac2)
!     	  call pgtext(xr2, y , frac2)
	 end if
	end if

	if(NORB.GT.1) then

	 if((j.ge.21.and.j.le.20+nst)
     1    .or.(j.eq.22+nst).or.(j.eq.23+nst)) then
    	  percent2 = ((lost(j,IORB)) * 100.) / real(ixrange)
    	  percent = percent-percent2
     	  write(frac2(:5), '(f5.1)') percent2
	  frac2=frac2(:5)//'%'
     	  write(frac(:5), '(f5.1)') percent
	  frac=frac(:5)//'%'
!   	  xr2 = xmin + (0.92 * (xmax - xmin))
   	  xr2 = xmin + (0.5 * (xmax - xmin))
          call pgsci(ired)
!     	  call pgtext(xr2, y + 0.3, frac2)
!     	  call pgtext(xr2, y , frac2)

	 end if
	end if




  220 format(i3,2h %)
  221 format('(',i3,' %)')

!      	 xr = xmin + (0.85 * (xmax - xmin))
      	 xr = xmin + (0.03 * (xmax - xmin))

!        call pgsci(icyellow)
!        call pgsci(icaltitude)
         call pgsci(iwhite)
!      	 call pgtext(xr, y + 0.3, frac)
!      	 call pgtext(xr, y , frac)
	 if(ioneplot.eq.1) then
!	  yr=y-0.5+(float(2*IORB-1)/float(2*NORB))
	  yr=y-0.5+0.1+(float(IORB-1)/float(NORB))
	 else
	  yr=y
	 end if

	 call pgsci(ictext)
      	 call pgtext(xr, yr , frac3)
	 call pgsci(iwhite)
	
	end if
      end do

! Plot horizontal lines


!      call pgvport(xplot(1),xplot(6),ybottom,ytop)
       call pgvport3(xplot(1),xplot(6),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)
  
      call pgwindow(xmin,xmax,0.5,ymax)
      call pgsci(iwhite)

	   y = 0

      do j = 1, inum-1
	if(apply(j,IORB)) then
      	    y = y+1.0
	   call pgmove(xmin,y+0.5)
	   call pgdraw(xmax,y+0.5)
	 end if
	end do


	   call pgmove(xplot(1),y+0.5)
	   call pgdraw(xplot(6),y+0.5)

	if(ioneplot.eq.1) then


!      call pgvport(xplot(2),xplot(6),ybottom,ytop)
       call pgvport3(xplot(2),xplot(6),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)

      call pgwindow(xmin,xmax,0.5,ymax)
      call pgsci(iwhite)

	   y = -0.5

       do j = 1, inum-1
	if(apply(j,IORB)) then
      	    y = y+1.0
	   call pgmove(xmin,y+0.5)
	   call pgdraw(xmax,y+0.5)
	 end if
	end do

	end if



	if(ioneplot.eq.1.and.IORB.eq.1) then

!      call pgvport(xplot(1),xplot(2),ybottom,ytop)
       call pgvport3(xplot(1),xplot(2),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)

  
      call pgwindow(0.0,1.0,0.5,ymax)

	 dx=0.1
	 x5=1.0-dx
	 x6=1.0-0.7*dx
	 dy1=0.1
	 dy2=0.5+dy1


	call pgmove(x5,0.0)
	call pgdraw(x5,ymax-2.0)

	   y = -0.5

       do j = 1, inum-1
	if(apply(j,IORB)) then
      	    y = y+1.0
!	   call pgtext(x6,y+dy1,'1')
!	   call pgtext(x6,y+dy2,'2')
	   call pgtext(x6,y+dy1,char(1))
	   call pgtext(x6,y+dy2,char(2))
	   call pgmove(x5,y+0.5)
	   call pgdraw(1.0,y+0.5)
	 end if
	end do

	end if

!        call pgebuf

	end do ! IORB=1,NORB

!	call pgend

	end if  ! end if(iplot.eq.1)


!	 write(*,*) 'Plot radio telescope usage ? (1=yes)'
!	 read(*,*) iplot

	iplot = 1

!	if(iplot.eq.1) then


	if(plotgrt) then

!         call pgbegin(20, plotf, 1, 1)




!	call pgbbuf


! plot radio telescope usage

      	ymin = 0.0
	ymax = float(ns) 
      	ij = 0

!	if(NORB.eq.1) then
!	 titleplot='RADIO TELESCOPE USAGE'
!	else
!         titleplot='TELESCOPE USAGE '// 
!     1     satname(1)//'(=1) and '//satname(2)//'(=2)'
!	end if

	 titleplot='RADIO TELESCOPE USAGE'

        call pgsci(iwhite)



! Plot station names

!      call pgadvance

!      call pgvport(xplot(1),xplot(2),ybottom,ytop)
       call pgvport3(xplot(1),xplot(2),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)
  
      call pgwindow(xmin,xmax,0.0,ymax)
      call pgsci(iwhite)
      call pgbox('bc',0.0,0.0,'bc',1.0,0.0)

	 call pgsch(20.0/float(inum))


	   y =  -0.5

       do j = 1, ns
      	    y = y+1.0
      	   xl = xmin + (0.02 * (xmax - xmin))
	   yl = y - 0.2
	   call pgsci(ictext)
      	   call pgtext(xl, yl , stname(j))
	   call pgsci(iwhite)
      	   isum1(j) = 0 
      	   isum2(j) = 0 
      	   isum4(j) = 0 
       end do


! Plot station usage

!	call pgsch(1.0)

!      call pgvport(xplot(3),xplot(4),ybottom,ytop)
       call pgvport3(xplot(3),xplot(4),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)

      call pgwindow(xminplot,xmaxplot,0.0,ymax)
      call pgsci(iwhite)
c     call pgbox('gbcnst',0.0,0.0,'bc',1.0,0.0)
c      call pgbox('gbcnmist',2.0,2,'bc',1.0,0)

      if(xmaxplot-xminplot.lt.1.) then
      xtick=0.1      
      else if(xmaxplot-xminplot.lt.6.) then      
      xtick=0.5
      else if(xmaxplot-xminplot.lt.12.) then      
      xtick=1.0
      else if(xmaxplot-xminplot.lt.28.) then
      xtick=2.
      else  if(xmaxplot-xminplot.lt.50.) then
      xtick=4.
      else  if(xmaxplot-xminplot.lt.100.) then
      xtick=8.
      else  if(xmaxplot-xminplot.lt.200.) then
      xtick=20.      
      else  if(xmaxplot-xminplot.lt.500.) then
      xtick=50.
      else  if(xmaxplot-xminplot.lt.700.) then
      xtick=100.
      else  
      xtick=200.      
      endif            

      call pgbox('gbcnmist',xtick,2,'bc',1.0,0)      
      call pgsch(0.7)
      call pgsci(ictext)
      call pglabel(xlabel,' ',titleplot)
      call pgsci(iwhite)

!     call pgslw(1)

	 call pgsch(20.0/float(inum))




	 y=-0.5


      do j = 1, ns

      	y = y+1.0

       do i = 1, ix

	if(time(i).ge.xmin.and.time(i).le.xmax) then

	 iline=1

      	  x = time(i)

	do k=1,2 
	 ground_on(k) = 0
	 do jj=1,ns
	   if ((type(jj).eq.1).and.up(i,jj,k)) ground_on(k) = 
     1                                         ground_on(k) + 1
	 end do
	end do

	do k=1,2 

      	if (up(i,j,k)) then

	 isum4(j)=isum4(j)+1

	 if(k.eq.1) isum1(j)=isum1(j)+1.0
	 if(k.eq.2) isum2(j)=isum2(j)+1.0

 	 call pgsls(iline)
         call pgsci(icgreen)

! there is a bug in the software that produced dark lines thru consplot
! diagram at a few epochs. This needs more investigations but the following
! is a quick fix hopefully. DWM 8-Aug-91

!	  xrect1=x-dt

!	  xrect1=time(i-1)
!	  xrect2=x

	  xrect1=time(i)-0.5*dt
	  xrect2=time(i)+0.5*dt

	  yrect1=y-dy
	  yrect2=y+dy

          if (k.eq.1) call pgsci(icgreen)
          if (k.eq.2) call pgsci(icyan)

	  if ((type(j).eq.2).and.(ground_on(k).lt.1)) then
	    call pgsci(icyellow)
	    isum4(j)=isum4(j)-1
	  end if

C	  if(NORB.eq.1.or.combined(i)) then
C	   yrect1=y-0.5
C	   yrect2=y+0.5
C	  else
C	   if(k.eq.1) then
C	    yrect1=y-0.5
C	    yrect2=y
C	   else
C	    yrect1=y
C	    yrect2=y+0.5
C	   end if
C	  end if

  	  call pgrect(xrect1,xrect2,yrect1,yrect2)
	 
       	end if

        end do  !  end do k=1,2

! crude source change 

	  call pgsci(ired)
!	  call pgslw(3)

	if(NORB.eq.1) then
	 if(change1(i)) then
	  call pgmove(x,y-0.5)
	  call pgdraw(x,y+0.5)
	 end if
	else
	 if(change1(i)) then
	  call pgmove(x,y-0.5)
	  call pgdraw(x,y+0.5)
	 end if	 	
	 if(change2(i)) then
	  call pgmove(x,y-0.5)
	  call pgdraw(x,y+0.5)
	 end if
	end if

	call pgsci(iwhite)
!	call pgslw(1)


	end if 

	 
       end do

      end do


! Plot Percentages

!     call pgslw(1)

!      call pgvport(xplot(5),xplot(6),ybottom,ytop)
       call pgvport3(xplot(5),xplot(6),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)
 
      call pgwindow(xmin,xmax,0.0,ymax)
      call pgsci(iwhite)
      call pgbox('bc',0.0,0.0,'bc',1.0,0.0)
      call pgsls(1)

!     call pgsch(1.0)
      call pgsch(20.0/float(inum))

	   y = -0.5

      do j = 1, ns

	  y = y + 1.0
     	 percent4 = (float(isum4(j)) * 100.) / float(ixrange)
         write(frac4(:5), '(f5.1)') percent4
	 frac4=frac4(:5)//'%'
      	 xr = xmin + (0.03 * (xmax - xmin))
	 yr = y - 0.2

	 call pgsci(ictext)
      	 call pgtext(xr, yr , frac4)
	 call pgsci(iwhite)
	
      end do

! Plot horizontal lines


!      call pgvport(xplot(1),xplot(6),ybottom,ytop)
       call pgvport3(xplot(1),xplot(6),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)

        call pgwindow(xmin,xmax,0.0,ymax)
      call pgsci(iwhite)

	   y = -1.0

        do j = 1, ns
      	    y = y+1.0
	   call pgmove(xmin,y)
	   call pgdraw(xmax,y)
	end do


	y= -1.0 

	if(NORB.ne.1) then

!      call pgvport(xplot(1),xplot(2),ybottom,ytop)
       call pgvport3(xplot(1),xplot(2),ybottom,ytop,
     1 x1vp,x2vp,y1vp,y2vp,fracvp)

      call pgwindow(0.0,1.0,0.0,ymax)

C	 dx=0.1
C	 x5=1.0-dx
C	 x6=1.0-0.7*dx
C	 dy1=0.1
C	 dy2=0.5+dy1
C
C	write(*,*) 'x5,x6',x5,x6
C
C	call pgmove(x5,0.0)
C	call pgdraw(x5,ymax)
C
C	   y = -1.0
C
C       do j = 1, ns
C      	    y = y+1.0
C	   call pgtext(x6,y+dy1,'1')
C	   call pgtext(x6,y+dy2,'2')
C	   call pgmove(x5,y+0.5)
C	   call pgdraw(1.0,y+0.5)
C	end do

	end if


!	call pgebuf
!      	call pgend

	end if  ! end if(iplot.eq.1)

!	write(*,*) 'options: '
!	write(*,*) '0  = end program '
!      	write(*,*) '1 = plot on  different device'
!      	write(*,*) '2 = change timerange'

!        if(isuppress.eq.1) then
!      	write(*,*) '3 = unsuppress individual spacecraft constraints '
!	else
!      	write(*,*) '3 = suppress individual spacecraft constraints '
!	end if

!      	read(*, *) ians

	ians = 0

      if (ians .eq. 1) goto 100
      if (ians .eq. 2) then 
	 ixchange=1
         goto 200
      end if

      if (ians .eq. 3) then
	if(isuppress.eq.1) then
	  isuppress=0
	else
	  isuppress=1
	end if
       goto 300
      end if

! plot KEY to colors here

      if(plotcons) then

! note key only plotted for single spacecraft options

	skip = .true.

	if(.not.skip) then
	write(*,*) ' '
	write(*,*) 'color scheme of tracking station viewperiods:'
	write(*,*) ' '
	write(*,*) 'green  = Tracking station that tracked spacecraft'
	write(*,*) 'yellow = Tracking station could have tracked spacecraft'
	write(*,*) 'lt grey= Spacecraft tracking conflict prevented this spacecraft'
	write(*,*) '          from being tracked by this tracking station'
	write(*,*) 'red    = Spacecraft tracking conflict prevented this spacecraft'
	write(*,*) '         from being tracked at this epoch'
	write(*,*) 'white  = spacecraft visible from tracking station but spacecraft'
	write(*,*) '          constraints are broken'
	write(*,*) ' '
	end if

        call pgvport3(xplot(6),xright,ybottom,ytop,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)

	call pgwindow(0.0,1.0,0.0,1.0)

	y_text = 0.75
	dy_text = 0.05

	x1 = 0.25
	x2 = 0.75

	x3 = 0.1

	call pgsci(iwhite)

c	call pgptext(0.5,y_text,0.0,0.5,'KEY')
	y_text = y_text - dy_text

!	write(*,*) 'x1,x2,x3: ',x1,x2,x3

	
	num_text(1) = 1
	key_text(1,1) = 'constraints met'

	num_text(2) = 1
	key_text(2,1) = 'redundant tracking station'

	num_text(3) = 2
	key_text(3,1) = 'visible but'
	key_text(3,2) = 'constraints broken'

	do i=1,3

	y1 = y_text - 0.25*dy_text
	y2 = y_text + 0.25*dy_text

	if(i.eq.1) call pgsci(icgreen)
	if(i.eq.2) call pgsci(icyellow)
	if(i.eq.3) call pgsci(iwhite)

	call pgrect(x1,x2,y1,y2)

	call pgsci(iwhite)

	call pgmove(x1,y1)
	call pgdraw(x2,y1)
	call pgdraw(x2,y2)
	call pgdraw(x1,y2)
	call pgdraw(x1,y1) 

	y_text = y_text - dy_text

	do j=1,num_text(i)
	 call pgtext(x3,y_text,key_text(i,j))
	 y_text = y_text - dy_text
	end do
	
	end do

      end if

      if(plotgrt) then


        call pgvport3(xplot(6),xright,ybottom,ytop,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)

	call pgwindow(0.0,1.0,0.0,1.0)

	y_text = 0.75
	dy_text = 0.05

	x1 = 0.25
	x2 = 0.75

	x3 = 0.1

	call pgsci(iwhite)

	call pgptext(0.5,y_text,0.0,0.5,'KEY')
	y_text = y_text - dy_text

!	write(*,*) 'x1,x2,x3: ',x1,x2,x3

	num_text(1) = 2
	key_text(1,1) = 'Ground Telescope:'
	key_text(1,2) = 'source visible'

	num_text(2) = 3
	key_text(2,1) = 'Spacecraft:'
	key_text(2,2) = 'source visible and'
	key_text(2,3) = 'co-observing GRT'

	num_text(3) = 3
	key_text(3,1) = 'Spacecraft:'
	key_text(3,2) = 'source visible and'
	key_text(3,3) = 'NO co-observing GRT'

	do i=1,3

	y1 = y_text - 0.25*dy_text
	y2 = y_text + 0.25*dy_text

	if(i.eq.1) call pgsci(icgreen)
	if(i.eq.2) call pgsci(icgreen)
	if(i.eq.3) call pgsci(icyellow)

	call pgrect(x1,x2,y1,y2)

	call pgsci(iwhite)

	call pgmove(x1,y1)
	call pgdraw(x2,y1)
	call pgdraw(x2,y2)
	call pgdraw(x1,y2)
	call pgdraw(x1,y1) 

	y_text = y_text - dy_text

	do j=1,num_text(i)
	 call pgtext(x3,y_text,key_text(i,j))
	 y_text = y_text - dy_text
	end do
	
	end do

      end if

      if(plotnum.or.plotprob) then


        call pgvport3(xplot(6),xright,ybottom,ytop,
     1  x1vp,x2vp,y1vp,y2vp,fracvp)

	call pgwindow(0.0,1.0,0.0,1.0)

	y_text = 0.75
	dy_text = 0.05

	x1 = 0.25
	x2 = 0.75

	x3 = 0.1

	call pgsci(iwhite)

	call pgptext(0.5,y_text,0.0,0.5,'KEY')
	y_text = y_text - dy_text


!	 write(*,*) 'x1,x2,x3: ',x1,x2,x3

	 num_text(1) = 2
	 key_text(1,1) = '# of telescopes when'
	 key_text(1,2) = 'spacecraft can observe'

	 num_text(1) = 4
	 str6 = ' '
	 write(str6,'(f6.2)') m1
	 key_text(1,3) = 'mean : '//str6
	 str6 = ' '
	 write(str6,'(f6.2)') sd1
	 key_text(1,4) = 'st dev : '//str6	 

	 num_text(2) = 1
	 key_text(2,1) = '# of ground telescopes'

	 num_text(2) = 3
	 str6 = ' '
	 write(str6,'(f6.2)') m2
	 key_text(2,2) = 'mean : '//str6
	 str6 = ' '
	 write(str6,'(f6.2)') sd2
	 key_text(2,3) = 'st dev : '//str6	 


	do i=1,2


	x1 = 0.1
	x2 = 0.9

	call pgsch(2.0)

	if(i.eq.1) call pgsci(icgreen)
	if(i.eq.2) call pgsci(icyellow)
c	if(i.eq.2) call pgsci(ired)	
c	if(i.eq.2) call pgsci(iorange)
	call pgsls(i)
	call pgmove(x1,y_text)
	call pgdraw(x2,y_text)

	x12= 0.5 * (x1 + x2)

	if(plotprob) then
	 call pgpoint(1,x12,y_text,ipoint(i))
	end if

	y_text = y_text - dy_text
		
	call pgsch(0.7)


	do j=1,num_text(i)
!	 write(*,*) 'j, num_text(i): ',j,num_text(i)
	 call pgtext(x3,y_text,key_text(i,j))
	 y_text = y_text - dy_text
	end do
	
	end do

      end if





       call pgebuf
!      call pgend

      return
 
!  999 write(6, *) 'ERR I/O'
!      return 

5000  continue

      write(*,*) ' '
      write(*,*) 'number of time steps in data set is: ',it
      write(*,*) 'this exceeds the maximum allowed   :'  ,MAXT
      write(*,*)  ' '
      write(*,*) 'ABORTING plotting of data set'
      write(*,*) ' '
      write(*,*) '(try using a smaller time range or '
      write(*,*) 'a larger integration period) '
      write(*,*) ' '

      return

      end
