
!         SUBROUTINE FITMOD

          SUBROUTINE FITMOD(IN1,IN2,IN3,IN4,IN5,IN6,
     1    OUT1,OUT2,OUT3,OUT4,OUT5,OUT6,
     2    MODVARY1,MODVARY2,MODVARY3,MODVARY4,MODVARY5,MODVARY6,
     3    GRADSRCH,TOTLAF3)

C234567890123456789012345678901234567890123456789012345678901234567890


	

C      PROGRAM MODELFIT
C DWM 10-APR-92 take Modelfit program and alter it to work inside FAKESAT
C Fits a single Gaussian model

C-----------------------------------------------------------------------
C Written and produced by Richard S. Simon, July 1981
C This program attempts to minimize the agreement factor for the
C fit of a model to VLB data.
C
C Version  1: July 28, 1981
C Version  2: Nov 16, 1981    Decrease max# of iterations
C Version  3: Dec 22, 1981
C Version  4: Feb  4, 1982    Add underlying model option
C Version  5: May  6, 1982   Fix a bug in BUVDATA, change array sizes
C Version  6: June 8, 1982   Add model type 6 (Optically thin Sphere)
C Version  7: July 7, 1983   Extend to include Merge format
C        (D. Meier)                     version 2 files; change BUVDATA
C                                       to BWTDATA.
C             Aug  3, 1983   Added W to version 2 files.
C             Oct 17, 1983   Corrected bug in BVIS when QQ=0.0
C                            Don't bother doing VIS calc if ERR <= 0
C Version  8: 1985 Feb 7   [TJP] Fix bug found by VMS4.0:
C                          attempting to read SYS$OUTPUT.
C Version  9: 1988 Apr 18  [TJP] Convex version.
C Version 10: 1989 Mar 29  [TJP] Improved performance (vectorized).
C Version 11: 1990 Nov  5  [TJP] Fix serious bug: it would give the 
C                          wrong answer on files containing an
C                          incomplete set of baselines or triangles.
C-----------------------------------------------------------------------
             

      INCLUDE 'fakesat.inc'
C
!     INTEGER VLBOPE, GETIN
      INTEGER VLBOPE
!     LOGICAL QUERY
      LOGICAL GRADSRCH
      LOGICAL MODVARY1,MODVARY2,MODVARY3
      LOGICAL MODVARY4,MODVARY5,MODVARY6
      REAL IN1,IN2,IN3,IN4,IN5,IN6
      REAL OUT1,OUT2,OUT3,OUT4,OUT5,OUT6
      REAL TOTLAF3,AFLIM1




C

! Take out elapsed time and cpu time calculation as
! this is machine specfic DWM 28-July-95

!     CALL SCLOCK
      CALL PUTOUT('Program MODELFIT  --  1990 Nov 5')
      CALL PUTOUT(' ')
C
C Get the file name for data file:
C

!  10 IER = GETIN(INDSN, 'Input data file name: ', L)
!     IF (IER.NE.1) STOP
!     IER = VLBOPE(INDAT, INDSN(1:L), 'MERGE', 'OLD', INDSN)
!     IF (IER.NE.1) GOTO 10

      IER = VLBOPE(INDAT,'data.dat', 'MERGE', 'OLD', INDSN)

C
C Get the input data and compute the arrays UDATA and VDATA:
C
      CALL BGETDAT

      CLOSE(INDAT)
C Determine which triangles are independent for each data record:
C
      CALL BTRIANGLE
C
C Compute the non-zero data points and the weights for the data.
C
      CALL BWTDATA
C
C Get underlying (constant) part of input model, if any:
C
      CALL UNDERMOD
C
      FRSTRY = .TRUE.
C
C Line to come back to when trying a new model:
C
  100 CONTINUE
C
C Read in and edit the model file:
C

!      CALL BGETMOD(IN1,IN2,IN3,IN4,IN5,IN6)


	NCOMP    = 1
        FLUX(1)  = IN1
	RADIUS(1)= IN2
	THETA(1) = IN3
	AXIS(1)  = IN4
	RATIO(1) = IN5
	PHI(1)   = IN6
	TYPE(1)  = 1

! extra variable need to be set up because
! BGETMOD has not been called

C         Save the initial model.
          FLSTRT(1) = FLUX(1)
          RASTRT(1) = RADIUS(1)
          THSTRT(1) = THETA(1)
          AXSTRT(1) = AXIS(1)
          ARSTRT(1) = RATIO(1)
          PHSTRT(1) = PHI(1)
          RTHETA(1) = DEGRAD*THETA(1)
          RPHI(1)   = DEGRAD*PHI(1)

C
C Compute and display the initial fit.
C
      METHOD = 'Initial model'
      JITER = 0
      DO J=1,NCOMP
          CALL BVIS(J)
      END DO
      CALL BMODAP
      CALL BAGRFAC
      CALL BAFOUTA
C
C Set up so that Control C's will be recognized.
C
      IF (FRSTRY) CALL CTRLCEN
C
C Fit the model:
C
      CALL PUTOUT(' ')
!      IF (QUERY('Well, should we try a gradient search? (Y or N): ')) 
!     1    THEN
!          CALL GRADLS(AFLIM)
!      END IF
C
!      CALL PUTOUT(' ')
!      IF (QUERY('Well, should we try a brute force (grid)'//
!     1         ' fit? (Y or N): ')) THEN
!          CALL GRIDLS(AFLIM)
!      END IF

! DWM start of addition


	VARY(1,1)=MODVARY1  ! Flux density
	VARY(2,1)=MODVARY2  ! distance from origin
	VARY(3,1)=MODVARY3  ! PA from origin
	VARY(4,1)=MODVARY4  ! Major axis
	VARY(5,1)=MODVARY5  ! axial ratio
	VARY(6,1)=MODVARY6  ! PA of component

	NVAR=0

	 IF(MODVARY1) NVAR=NVAR+1
	 IF(MODVARY2) NVAR=NVAR+1
	 IF(MODVARY3) NVAR=NVAR+1
	 IF(MODVARY4) NVAR=NVAR+1
	 IF(MODVARY5) NVAR=NVAR+1
	 IF(MODVARY6) NVAR=NVAR+1
	

	if(GRADSRCH) then
	 CALL GRADLS(AFLIM1)
	else          
         CALL GRIDLS
	end if

! DWM end of addition


C
C Write the agreement factors and model to the output units:
C
!       CALL BAFOUT

	OUT1=FLUX(1)
        OUT2=RADIUS(1)
        OUT3=THETA(1)
        OUT4=AXIS(1)	
        OUT5=RATIO(1)
	OUT6=PHI(1)


C
C Let the user try again, if desired:
C

!      IF (QUERY('Would you like to try again? (Y or N): ')) THEN
!          FRSTRY = .FALSE.
!          GO TO 100
!      END IF

! DWM addition:

	TOTLAF3 = TOTLAF

	RETURN

C-----------------------------------------------------------------------
      END
      SUBROUTINE BAFOUT
C
C       By Richard S. Simon
C
C       This prints the results from program MODELFIT to unit INMOD
C       (e.g., a model with comments), and a summary to unit OUTC.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
      CHARACTER*64 MODNAM, OLDMOD
      CHARACTER*24 MESSGE
      CHARACTER*80 HISTRY


! Take out elapsed time and cpu time calculation as
! this is machine specfic DWM 28-July-95

!     CHARACTER*8  ELAPSE
!     REAL CPU

      REAL STAR
       CHARACTER*4 STARCH0
       EQUIVALENCE (STAR,STARCH0)
      DATA STARCH0/'*   '/

      CHARACTER*1 VARIED,FIXED,FLAG(6,MXMOD)
      PARAMETER (VARIED='v',FIXED=' ')
      INTEGER VLBOPE, GETIN
C
C Close the input model file.
C
      INQUIRE (UNIT=INMOD, NAME=MODNAM)
      CLOSE (UNIT=INMOD)
      OLDMOD = MODNAM
C
C Open the output model file.
C
   17 IER = VLBOPE(INMOD, MODNAM, 'MODEL', 'NEW', MODNAM)
      IF (IER.NE.1) THEN
          IER = GETIN(MODNAM, 'Name for output model file: ', L)
          IF (IER.NE.1) STOP
          GOTO 17
      END IF
C
C Write the header in the output model file.
C
      CALL MKHIST('MODELFIT', ' 5-Nov-1990', HISTRY)
      L = LEN1(HISTRY)
      WRITE (INMOD,1000) '! ',HISTRY(1:L)
      L = LEN1(INDSN)
      WRITE (INMOD,1000) '! Input data file:   ',INDSN(1:L)
      L = LEN1(OLDMOD)
      WRITE (INMOD,1000) '! Input model file:  ',OLDMOD(1:L)
      IF (UNDMOD) THEN
C         There was an underlying model file, so write it out:
          INQUIRE (FILE=UNDDSN,NAME=MODNAM)
          LEN = INDEX(MODNAM,' ')-1
          WRITE (INMOD,1000) '!'
          WRITE (INMOD,1000) '! An underlying (constant) model was ',
     1    'used for this fit.'
          WRITE (INMOD,1000) '! Name of underlying file: ',MODNAM(1:LEN)
      ENDIF
C
      ZFREQ = FREQ / 1.E6
      WRITE (INMOD,1008) SOURCE,NDAY,NYEAR,ZFREQ
      WRITE (INMOD,1000) '!'
      WRITE (INMOD,1000) '! Baseline       Agreement          ',
     1'        Triangle       Agreement'
      WRITE (INMOD,1000) '!                   Factor          ',
     1'                          Factor'
C
C  I1 = JMIN0(NUMBAS,NUMTRI)

      I1 = MIN0(NUMBAS,NUMTRI)
      I2 = I1 + 1
      DO 100 I=1,I1
          IF (VISAF(I) .GT. 0. .AND. CLOAF(I) .GT. 0.) THEN
            ASSIGN 1001 TO IFORM
          ELSEIF (VISAF(I) .LT. 0. .AND. CLOAF(I) .LT. 0.) THEN
            ASSIGN 1004 TO IFORM
            VISAF(I) = STAR
            CLOAF(I) = STAR
          ELSEIF (VISAF(I) .LT. 0.) THEN
            ASSIGN 1002 TO IFORM
            VISAF(I) = STAR
          ELSE
            ASSIGN 1003 TO IFORM
            CLOAF(I) = STAR
          ENDIF
          WRITE (INMOD,IFORM) STNAME(NAVIS(I)),STNAME(NBVIS(I)),
     1    VISAF(I), STNAME(NACLO(I)), STNAME(NBCLO(I)),
     1    STNAME(NCCLO(I)), CLOAF(I)
  100 CONTINUE
C
      IF (NUMBAS .GT. NUMTRI) THEN
          DO 120 I = I2, NUMBAS
            IF (VISAF(I) .LT. 0.) THEN
              ASSIGN 1002 TO IFORM
              VISAF(I) = STAR
            ELSE
              ASSIGN 1001 TO IFORM
            ENDIF
            WRITE (INMOD,IFORM) STNAME(NAVIS(I)),STNAME(NBVIS(I)),
     1      VISAF(I)
  120     CONTINUE
      ELSEIF (NUMTRI .GT. NUMBAS) THEN
          DO 140 I = I2, NUMTRI
C           If AF is <0, print a star instead of AF.
            IF (CLOAF(I) .GT. 0.) THEN
              ASSIGN 1005 TO IFORM
            ELSE
              ASSIGN 1006 TO IFORM
              CLOAF(I) = STAR
            ENDIF
            WRITE (INMOD,IFORM) STNAME(NACLO(I)), STNAME(NBCLO(I)),
     1      STNAME(NCCLO(I)), CLOAF(I)
  140     CONTINUE
      ENDIF
      IF (AMPLAF .GE. 0. .AND. PHASAF .GE. 0.) THEN
          ASSIGN 1007 TO IFORM
      ELSEIF (AMPLAF .GE. 0.) THEN
          ASSIGN 1014 TO IFORM
          PHASAF = STAR
      ELSE
          ASSIGN 1015 TO IFORM
          AMPLAF = STAR
      ENDIF
      WRITE (INMOD,IFORM) '! Total amplitude agreement factor:',AMPLAF,
     1'! Total phase clo agreement factor:',PHASAF,
     2'! Total agreement factor:',TOTLAF
      WRITE (INMOD,1016) '! Equivalent number of ind. data ',
     1'points:',TNZDAT
      WRITE (INMOD,1000) '!'
      WRITE (INMOD,1000) '! Starting Model (v => variable parameter):'
      WRITE (INMOD,1000) '! #      Flux     Radius      Theta ',
     1'      Axis      Ratio        Phi       Type'
      WRITE (INMOD,1009) (J,FLSTRT(J),FLAG(1,J),RASTRT(J),FLAG(2,J),
     1THSTRT(J),FLAG(3,J),AXSTRT(J),FLAG(4,J),ARSTRT(J),FLAG(5,J),
     2PHSTRT(J),FLAG(6,J),TYPE(J), J=1,NCOMP)
      WRITE (INMOD,1000) '!'
      WRITE (INMOD,1000) '! Final Model:'
      WRITE (INMOD,1000) '!        Flux     Radius      Theta ',
     1'      Axis      Ratio        Phi       Type'
      WRITE (INMOD,1010) (FLUX(J),RADIUS(J),THETA(J),AXIS(J),
     1RATIO(J),PHI(J),TYPE(J), J=1,NCOMP)
      GO TO 200
C
C Write summary to terminal:
C
      ENTRY BAFOUTA
  200 DO 210 J = 1, NCOMP
          THETA(J) = RTHETA(J)/DEGRAD
          PHI(J)   = RPHI(J)/DEGRAD
          DO 205 K=1,6
            IF (VARY(K,J)) THEN
              FLAG(K,J) = VARIED
            ELSE
              FLAG(K,J) = FIXED
            ENDIF
  205     CONTINUE
  210 CONTINUE
      WRITE (OUTC,1011) SOURCE, JITER, METHOD(1:15)
      WRITE (OUTC,1000) '  #      Flux     Radius      Theta ',
     1'     Axis      Ratio        Phi       Type'
      WRITE (OUTC,1012) (J,FLUX(J),FLAG(1,J),RADIUS(J),FLAG(2,J),
     1THETA(J),FLAG(3,J),AXIS(J),FLAG(4,J),RATIO(J),FLAG(5,J),
     2PHI(J),FLAG(6,J),TYPE(J), J=1,NCOMP)
C
C       Generate comment on quality of fit:
      IF (TOTLAF .LT. 0.5) THEN
          MESSGE = 'Too good to be true!'
      ELSEIF (TOTLAF .LT. 1.) THEN
          MESSGE = 'Astoundingly good!'
      ELSEIF (TOTLAF .LT. 2.) THEN
          MESSGE = 'I''m impressed.'
      ELSEIF (TOTLAF .LT. 3.) THEN
          MESSGE = 'Good'
      ELSE
          MESSGE = ' '
      ENDIF
C
      WRITE (OUTC,1013) 'Total amplitude agreement factor:',AMPLAF,
     1 'Total phase clo agreement factor:',PHASAF,
     2 'Total agreement factor:',TOTLAF,MESSGE

! Take out elapsed time and cpu time calculation as
! this is machine specfic DWM 28-July-95

!      CALL RCLOCK(ELAPSE, CPU)
!      WRITE (OUTC,1017) ELAPSE, CPU

C
      RETURN
C
 1000 FORMAT (A,A,A,A)
 1001 FORMAT ('! ',A4,'-',A4,6X,F10.3,12X,A4,'-',A4,'-',A4,6X,F10.3)
 1002 FORMAT ('! ',A4,'-',A4,6X,5X,A4,13X,A4,'-',A4,'-',A4,6X,F10.3)
 1003 FORMAT ('! ',A4,'-',A4,6X,F10.3,12X,A4,'-',A4,'-',A4,6X,5X,A4)
 1004 FORMAT ('! ',A4,'-',A4,6X,5X,A4,13X,A4,'-',A4,'-',A4,6X,5X,A4)
 1005 FORMAT ('!',38X,A4,'-',A4,'-',A4,6X,F10.3)
 1006 FORMAT ('!',38X,A4,'-',A4,'-',A4,6X,5X,A4)
 1007 FORMAT ('!'/2(A,F10.3/),A,F10.3)
 1008 FORMAT ('! Source: ',2A8,' Day:',I4,', Year:',I5,F15.2,' MHz')
 1009 FORMAT(('!',I2,4(F10.3,A),F10.4,A,F10.3,A,I10))
 1010 FORMAT ('  ',4F11.4,F11.5,F11.4,I11)
 1011 FORMAT (80('-')/' Source: ',2A8,'  Iteration #',I3,10X,A)
 1012 FORMAT((' ',I2,4(F10.3,A),F10.4,A,F10.3,A,I10))
 1013 FORMAT (/2(' ',A,F10.3/),' ',A,F10.3,5X,A)
 1014 FORMAT ('!'/A,F10.3/A,5X,A4/A,F10.3)
 1015 FORMAT ('!'/A,5X,A4/A,F10.3/A,F10.3)
 1016 FORMAT (A,A,F10.2)
 1017 FORMAT (' Elapsed time: ',A,';  cpu time: ',F10.2/)
      END
      SUBROUTINE BAGRFAC
C
C       By Richard S. Simon
C
C       This subroutine finds the agreement factors for the fit of a
C       model to VLB data.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
      REAL CSUM(MXTRI)
C
C Amplitude agreement factors.
C
      AMPSUM = 0.
      DO 20 IB = 1, NUMBAS
          IF (NZVIS(IB) .GT. 0) THEN
            VSUM = 0.
            DO 10 ID = 1, NUMREC
              IF (WTVIS(ID,IB) .GT. 0.0) THEN
                DELVIS = MODVIS(ID,IB) - OBSVIS(ID,IB)
                VSUM   = VSUM + WTVIS(ID,IB)*DELVIS*DELVIS
              ENDIF
   10       CONTINUE
            VISAF(IB) = SQRT (VSUM / NZVIS(IB))
            AMPSUM = AMPSUM + VSUM
          ELSE
            VISAF(IB) = -1.
          ENDIF
   20 CONTINUE
      IF (NZAMP .GT. 0) THEN
          AMPLAF = SQRT (AMPSUM / NZAMP)
      ELSE
          AMPLAF = -1.
      END IF
C
C Closure phase agreement factors, for each triangle.
C
      DO 25 IC=1,NUMTRI
          CSUM(IC) = 0.0
   25 CONTINUE
      CLOSUM = 0.
      IF (NUMTRI .GT. 0) THEN
          DO 40 ID = 1,NUMREC
            IF (NINTRI(ID) .GT. 0) THEN
              DO 30 IC = 1,NUMTRI
                IF (WTCLO(ID,IC) .GT. 0.) THEN
                  DELCLO = ABS (MODCLO(ID,IC) - OBSCLO(ID,IC))
                  IF (DELCLO .GT. PI) DELCLO = DELCLO - TWOPI
                  CSUM(IC) = CSUM(IC) + WTCLO(ID,IC)*DELCLO*DELCLO
                  CLOSUM = CLOSUM+DOWNWT(ID)*WTCLO(ID,IC)*DELCLO*DELCLO
                ENDIF
   30         CONTINUE
            ENDIF
   40     CONTINUE
      END IF
      DO 50 IC=1,NUMTRI
          IF (NZCLO(IC) .GT. 0) THEN
            CLOAF(IC) = SQRT (CSUM(IC)/NZCLO(IC))
          ELSE
            CLOAF(IC) = -1.
          END IF
   50 CONTINUE
C
      IF (TNZCLO .GT. 0.) THEN
          PHASAF = SQRT (CLOSUM/TNZCLO)
      ELSE
          PHASAF = -1.
      END IF
C
C Total agreement factor for all data.
C
      TOTLAF = SQRT ((AMPSUM+CLOSUM) / TNZDAT)
C
      RETURN
      END
      SUBROUTINE BGETDAT
C
C       By Richard S. Simon
C
C       Version 1:      27-July-1981
C       Version 2:      16-April-1982   Fix a bug in TAKE dimension
C       Version 3:       7-July-1983    Extend to include Merge
C                               version 2 files and compute U and V
C                                       D. Meier
C                        3-August-1983  Add W to version 2 files
C
C  This subroutine does the following:
C       1) Calls subroutine HEADX15 to get data parameters.
C       2) Reads in amplitude and closure phase data from data file.
C       3) Computes (or reads in) the U's and V's for a data set.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
C
      REAL    TAKE(MAXWPB*MXBAS + 2*MXTRI), SIDINT(MXREC), BZ(MXBAS),
     1    BXY(MXBAS), XIHA(MXBAS)
C
C
C       Call headx15 to get data parameters
      IOUT = 0
      IPROUT = 0
      CALL HEADX15(.FALSE., INDAT, IZERO, NDAY, NYEAR, IDUMMY, IDUM,
     +            IOUT, IUNITS, DUMMY, IFILE, IPROUT)
      IF (IFILE .NE. 0) THEN
          CALL ERROR('Something wrong with input file.')
      END IF
C
C       Certify that data is in flux units before proceeding.
      IF (IUNITS .NE. 1) THEN
          CALL ERROR('Data not in flux units.')
      END IF
C
      WRITE (OUTC,1007) SOURCE(1),SOURCE(2)
      LAMBDA = VELC/FREQ
C
C       Load NSTA, NBAS, etc into COMMON
      NUMSTA = NSTA
      NUMBAS = NBAS
      NUMTRI = NTRI
      NINDCL = (NUMSTA-1)*(NUMSTA-2)/2
C
      COSDEC = COS(DECP)
      SINDEC = SIN(DECP)
      IF (NVER.EQ.1) THEN
          DO IB = 1, NUMBAS
            BX       = (STX(NBVIS(IB))-STX(NAVIS(IB))) / LAMBDA
            BY       = (STY(NBVIS(IB))-STY(NAVIS(IB))) / LAMBDA
            BZ(IB)   = (STZ(NBVIS(IB))-STZ(NAVIS(IB))) / LAMBDA
            BHA      = ATAN2(BY,BX)
            BXY(IB)  = SQRT (BX*BX + BY*BY)
            XIHA(IB) = (GASTM-RAP-BHA+HALFPI) * RADHRS
          ENDDO
      ENDIF
C
C       Read in the data, compute UT
      NWORDS = NDWPB*NUMBAS + 2*NUMTRI
      DO 150 ID = 1, MXREC
          READ (INDAT, END=160)  IT, (TAKE(I), I = 1, NWORDS)
          IF (IT .EQ. -1) GO TO 160
C         Compute UT in hours
          UT(ID) = (IT - IZERO) / 216000.
          SIDINT(ID) = UT(ID) * SIDR
C         Get amplitudes and errors and UV values
          DO 130 IB = 1, NUMBAS
            K = NDWPB*(IB-1)
            OBSVIS(ID,IB) = TAKE(K+1)
            WTVIS(ID,IB)= TAKE(K+2)
            IF (NVER.EQ.1) THEN
              OBSIHA = XIHA(IB) + SIDINT(ID)
              RADIHA = OBSIHA / RADHRS
              UDATA(ID,IB) = (-BXY(IB)*COS(RADIHA)) / CONV1
              VDATA(ID,IB) = (BZ(IB)*COSDEC -
     1          BXY(IB)*SINDEC*SIN(RADIHA)) / CONV1
            ELSEIF (NVER.EQ.2) THEN
              UDATA(ID,IB) = - TAKE(K+5) / CONV1
              VDATA(ID,IB) = - TAKE(K+6) / CONV1
            ENDIF
  130     CONTINUE
C         Get closure phases and errors
          IF (NUMTRI .GT. 0.) THEN
            DO 140 IC = 1, NUMTRI
              K = NDWPB*NUMBAS + 2*(IC-1)
              OBSCLO(ID,IC)  = TAKE(K+1) * DEGRAD
              WTCLO(ID,IC) = TAKE(K+2)   * DEGRAD
  140       CONTINUE
          ENDIF
  150 CONTINUE
C       Not all the data was read in, so issue a warning:
      WRITE (OUTC,1008) MXREC,MXREC,MXREC
      ID = MXREC + 1
C
  160 CONTINUE
      NUMREC = ID - 1
C
 1007 FORMAT (/' Source:',2A8)
 1008 FORMAT(/' Well, it looks like you have blown it.  This version',
     + ' of the program will',
     +/' only handle',I4,' separate data records, i.e.,',I4,
     + ' separate UT''s.  Thus,',
     +/' only the first',I4,' times will be used in the fit.  I',
     + ' suggest you use the',
     +/' program AVERAGE to average your data somewhat.  Good luck.')
C
C       Print out the data during program checkout.
D       WRITE (69,9003)
D       DO 8100 IB = 1, NUMBAS
D         WRITE (69,9002) STNAME(NAVIS(IB)), STNAME(NBVIS(IB))
D         DO 8050 ID = 1,NUMREC
D           WRITE (69,9004) UT(ID), OBSVIS(ID,IB), WTVIS(ID,IB)
D8050     CONTINUE
D8100   CONTINUE
D       WRITE (69,9005)
D       IF (NUMTRI .LE. 0) THEN
D         WRITE (69,9008)
D         GO TO 8300
D       END IF
D       DO 8200 IC = 1, NUMTRI
D         WRITE (69,9006) STNAME(NACLO(IC)), STNAME(NBCLO(IC)),
D    +                   STNAME(NCCLO(IC))
D         WRITE (69,9007)
D         DO 8150 ID = 1, NUMREC
D           CLOSE = OBSCLO(ID,IC) / DEGRAD
D           ERROR = WTCLO(ID,IC) / DEGRAD
D           WRITE (69,9004) UT(ID),CLOSE, ERROR
D8150     CONTINUE
D8200   CONTINUE
D8300   CONTINUE
C
D9002   FORMAT (' Baseline: ',A4,' to ',A4)
D9003   FORMAT (/' Amplitude data and errors:'/)
D9004   FORMAT (' ',3F12.3)
D9005   FORMAT (//' Closure phase data and errors:'//)
D9006   FORMAT (' The triangle consists of stations ',A4,'-',A4,'-',A4/)
D9007   FORMAT ('      UT Time   Cl. Phase       Error'/)
D9008   FORMAT (' No closure phase information to be used'//)
C
      RETURN
      END
      SUBROUTINE BGETMOD
C
C       By Richard S. Simon
C  This subroutine interacts with the user to:
c       1) Get input file name for existing model, or open a new file
C          if necessary.
c       2) Allows changes to the model to be made.
C       3) Allows user to specify which parameters to be varied
C          during model fit.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
      CHARACTER*64 NEWDSN,OLDDSN
      CHARACTER*1  ANSWER
      REAL*8     NAMES(7), VALUES(7), ENDMRK
	CHARACTER*8 ENDMRKCH0
        EQUIVALENCE (ENDMRK,ENDMRKCH0)

      INTEGER IVARY(6)
      LOGICAL NEWMOD,DWM
      DATA    ENDMRKCH0/'***EOL'/
        CHARACTER*8 NAMESCH0(7) 
        EQUIVALENCE (NAMES,NAMESCH0)
C ***********NEXT initialization ************

        DATA NAMESCH0(1),  NAMESCH0(2),  NAMESCH0(3), 
     R  NAMESCH0(4),  NAMESCH0(5),  NAMESCH0(6), 
     R  NAMESCH0(7) 
     R /'FLux',  'RAdius',  'THeta', 
     R  'AXis',  'ARatio',  'PHi', 
     R                'TYpe' /
C ***********NEXT initialization ************
      INTEGER GETIN, VLBOPE
!     LOGICAL QUERY
C
C
      CALL PUTOUT(' ')
      IF (FRSTRY) THEN

!   20     IER = GETIN(MODDSN, 'Input model file name (default=create '//
!     1                'new model file): ', L)

! DWM start of addition:
20	  continue
          MODDSN = 'modelin.dat'
               L = 10
             IER = 1
! DWM end of addition:

          IF (IER.NE.1) STOP
          IF (L.LT.1) THEN
            NEWMOD = .TRUE.
          ELSE
            IER = VLBOPE(INMOD, MODDSN, 'MODEL', 'OLD', MODDSN)
            IF (IER.NE.1) GOTO 20
            NEWMOD = .FALSE.
          ENDIF
      ELSE
          INQUIRE (FILE=MODDSN,NAME=OLDDSN)
          LENGTH = INDEX(OLDDSN,' ') - 1
  120     IER = GETIN(NEWDSN, 'New input model file name (default='//
     1                OLDDSN(1:LENGTH) // '): ',L)
          IF (IER.NE.1) STOP
          IF (L.GT.0) THEN
            CLOSE (UNIT=INMOD)
            IER = VLBOPE(INMOD, NEWDSN, 'MODEL', 'OLD', MODDSN)
            IF (IER.NE.1) GOTO 120
            MODDSN = NEWDSN
          ELSE
            CLOSE (UNIT=INMOD)
            IER = VLBOPE(INMOD, MODDSN, 'MODEL', 'OLD', MODDSN)
            IF (IER.NE.1) GOTO 120
          ENDIF
          NEWMOD = .FALSE.
      ENDIF
      IF (NEWMOD) THEN
   25     IER = GETIN(MODDSN, 'Name of new model file to be created: ', 
     1                L)
          IF (IER.NE.1) STOP
          IER = VLBOPE(INMOD, MODDSN, 'MODEL', 'NEW', MODDSN)
          IF (IER.NE.1) GOTO 25
C         Type in the new model.
          WRITE (OUTC,1003)
          ITYPE = 0
          I = 0
   40     I = I+1
          IF (I .GT. MXMOD) GO TO 45
          CALL GTMODL(INC,ITYPE,FLUX(I),RADIUS(I),
     1    THETA(I),AXIS(I),RATIO(I),PHI(I), *45, 0)
          IF (FLUX(I) .NE. 0) THEN
            IF (ITYPE .EQ. 0) ITYPE = 1
            IF (ITYPE .LT. 1  .OR.  ITYPE .GT. 5) THEN
              CALL PUTOUT('Illegal component type in input model.'//
     +        '  Please repair!')
            ENDIF
            TYPE(I) = ITYPE
            IF (ITYPE .EQ. 5 .AND. RATIO(I) .NE. 0.) THEN
              WRITE (OUTC,1017)
              RATIO(I) = 0.
            END IF
            WRITE(INMOD,1004) FLUX(I),RADIUS(I),
     1      THETA(I),AXIS(I),RATIO(I),PHI(I),ITYPE
            GO TO 40
          END IF
   45     CONTINUE
      ELSE
          I = 0
   50     I = I+1
          IF (I .GT. MXMOD) GO TO 55
          CALL GTMODL(INMOD,ITYPE,FLUX(I),RADIUS(I),
     1    THETA(I),AXIS(I),RATIO(I),PHI(I), *55, 0)
          IF (FLUX(I) .NE. 0.) THEN
            IF (ITYPE .EQ. 0) ITYPE = 1
            IF (ITYPE .LT. 1  .OR.  ITYPE .GT. 5) THEN
              CALL PUTOUT('Illegal component type in input model.'//
     +        '  Please repair!')
            ENDIF
            TYPE(I) = ITYPE
            IF (ITYPE .EQ. 5 .AND. RATIO(I) .NE. 0.) THEN
              WRITE (OUTC,1017)
              RATIO(I) = 0.
            END IF
            GO TO 50
          END IF
   55     CONTINUE
      END IF
C
      NCOMP = I-1
   65 WRITE (OUTC,1006)
      WRITE (OUTC,1005)
      WRITE  (OUTC,1013) (I,FLUX(I),RADIUS(I),THETA(I),
     1 AXIS(I),RATIO(I),PHI(I),TYPE(I), I = 1, NCOMP)
C
!      IF (.NOT.QUERY('Is this acceptable? (Y or N): ')) THEN
	DWM=.TRUE.
	IF(.NOT.DWM) then
          WRITE (OUTC,1008)
          READ  (INC,1000) ANSWER
          CALL UPCASE (ANSWER)
          IF (ANSWER .EQ. 'C' .OR. ANSWER .EQ. 'B') THEN
C           Changes to model
            WRITE (OUTC,1010)
            DO 80 I = 1, NCOMP
              DO 70 J = 1, 7
                VALUES(J) = -1000.
   70         CONTINUE
              WRITE(OUTC,1009) I,FLUX(I),RADIUS(I),
     1        THETA(I),AXIS(I),RATIO(I),PHI(I),TYPE(I)
              MODE = 2
              CALL KEYIN(NAMES, VALUES, 7, ENDMRK, MODE, INC, OUTC)
              IF (VALUES(1) .NE. -1000.)  FLUX(I) = VALUES(1)
              IF (VALUES(2) .NE. -1000.)RADIUS(I) = VALUES(2)
              IF (VALUES(3) .NE. -1000.) THETA(I) = VALUES(3)
              IF (VALUES(4) .NE. -1000.)  AXIS(I) = VALUES(4)
              IF (VALUES(5) .NE. -1000.) RATIO(I) = VALUES(5)
              IF (VALUES(6) .NE. -1000.)   PHI(I) = VALUES(6)
              IF (VALUES(7) .NE. -1000.)  TYPE(I) = VALUES(7)
              IF (TYPE(I) .EQ. 5 .AND. RATIO(I) .NE. 0.) THEN
                RATIO(I) = 0.
                WRITE (OUTC,1018)
              END IF
   80       CONTINUE
C
C           Remove components with FLUX=0 from model
   81       JSTOP = NCOMP-1
            DO 83 J = 1, JSTOP
              IF (FLUX(J) .EQ. 0.) GO TO 82
   83       CONTINUE
            GO TO 86
   82       DO 84 K = J, NCOMP-1
                FLUX(K) = FLUX(K+1)
                RADIUS(K)  = RADIUS(K+1)
                THETA(K) = THETA(K+1)
                AXIS(K)   = AXIS(K+1)
                RATIO(K)   = RATIO(K+1)
                PHI(K) = PHI(K+1)
                TYPE(K) = TYPE(K+1)
   84       CONTINUE
            NCOMP = NCOMP-1
            GO TO 81
   86       IF (FLUX(NCOMP) .EQ. 0.) NCOMP = NCOMP-1
C
          END IF
          IF (ANSWER .EQ. 'A' .OR. ANSWER .EQ. 'B') THEN
C           Additions:
            WRITE (OUTC,1011)
            WRITE (OUTC,1013) (I,FLUX(I),RADIUS(I),
     1      THETA(I),AXIS(I),RATIO(I),PHI(I),TYPE(I), I = 1, NCOMP)
            ITYPE = 0
            I = NCOMP
   90       I = I+1
            IF (I .LE. MXMOD) THEN
              WRITE (OUTC,1012) I
              CALL GTMODL (INC,ITYPE,FLUX(I),RADIUS(I),
     1        THETA(I),AXIS(I),RATIO(I),PHI(I), *95, 0)
              IF (FLUX(I) .NE. 0) THEN
                IF (ITYPE .EQ. 0) ITYPE = 1
                IF (ITYPE .LT. 1  .OR.  ITYPE .GT. 5) THEN
                  CALL PUTOUT('Illegal component type in input '//
     +            'model.  Please repair!')
                ENDIF
                TYPE(I) = ITYPE
                IF (ITYPE .EQ. 5 .AND. RATIO(I) .NE. 0.) THEN
                  WRITE (OUTC,1017)
                  RATIO(I) = 0.
                END IF
                GO TO 90
              END IF
            ELSE
              CALL PUTOUT('That is the maximum number of model'//
     1        ' components, at present.')
            ENDIF
   95       NCOMP = I-1
          END IF
          CLOSE (UNIT=INMOD)
          OPEN  (UNIT=INMOD, NAME=MODDSN, TYPE='UNKNOWN',
     1           FORM='FORMATTED')
          DO 100 I = 1, NCOMP
            WRITE(INMOD,1004) FLUX(I),RADIUS(I),
     1      THETA(I),AXIS(I),RATIO(I),PHI(I),TYPE(I)
  100     CONTINUE
C
          ISTART = NCOMP + 1
          DO 105 I = ISTART, MXMOD
            FLUX(I) = 0.
  105     CONTINUE
          GO TO 65
      END IF
C
      DWM=.TRUE.
      if(.NOT.DWM) then
      NVPAR = 0
      WRITE (OUTC,1014)
      WRITE (OUTC,1005)
      DO 150 I = 1, NCOMP
  115     WRITE(OUTC,1113)I,FLUX(I),RADIUS(I),
     1      THETA(I),AXIS(I),RATIO(I),PHI(I),TYPE(I)
          DO 130 J = 1, 6
            IVARY(J) = 0
            VARY(J,I) = .FALSE.
  130     CONTINUE
          READ (INC,1015,ERR=115)IVARY
C         Make sure AR not varied for line component; correct if necessary.
          IF (TYPE(I) .EQ. 5) THEN
            DO 145 J = 1, 6
              IF (IVARY(J) .EQ. 5) THEN
                IVARY(J) = 0
                WRITE (OUTC,1016)
              ENDIF
  145       CONTINUE
          END IF
C
          DO 140 J = 1, 6
            IF (IVARY(J) .GT. 0 .AND. IVARY(J) .LT. 7) THEN
              NVPAR = NVPAR+1
              VARY(IVARY(J),I) = .TRUE.
            END IF
  140     CONTINUE
  150 CONTINUE
      end if ! if(DWM)
C
C
      FLXSUM = 0.0
      DO 108 J = 1, NCOMP
          FLXSUM = FLXSUM + FLUX(J)
C         Save the initial model.
          FLSTRT(J) = FLUX(J)
          RASTRT(J) = RADIUS(J)
          THSTRT(J) = THETA(J)
          AXSTRT(J) = AXIS(J)
          ARSTRT(J) = RATIO(J)
          PHSTRT(J) = PHI(J)
          RTHETA(J) = DEGRAD*THETA(J)
          RPHI(J)   = DEGRAD*PHI(J)
  108 CONTINUE
C
 1000 FORMAT (A,A,A,A)
 1003 FORMAT (' Enter new model, 1 component (6 parameters) per line,'/
     +        ' Flux, Rad., Theta, Axis, Ratio, Phi, all separated ',
     +        'by one or more blanks;'/
     +        ' End input with ctrl-D (UNIX) or ctrl-Z (VMS):')
 1004 FORMAT (6F10.3, I5)
 1005 FORMAT (12X,'Flux',3X,'Radius',4X,'Theta',5X,'Axis',4X,'Ratio',
     +          6X,'Phi','  Type')
 1006 FORMAT (//' Starting Model:')
 1008 FORMAT (' Do you wish to make Changes/Deletions, Additions,',
     +          ' or Both (C, A, or B) ? ',$)
 1009 FORMAT (' Changes to ',I2,')',4X,6F9.3,I5)
 1010 FORMAT (//' Enter changes, 1 component at a time using Free',
     +        ' Format (e.g. "FL=3.1  TH=113").'
     +        /' To delete a component, change the flux to 0.0'
     +        /' To go to next component, hit RETURN key.'
     +        /23X,'FL',7X,'RA',7X,'TH',7X,'AX',7X,'AR',7X,'PH',7X,'TY')
 1011 FORMAT (/' Enter new components (separate parameter values by',
     +         ' blanks);'
     +        /' End input with ctrl-D (UNIX) or ctrl-Z (VMS):')
 1012 FORMAT (1X,I5,')',$)
 1013 FORMAT (1X,3X,I2,')',6F9.3,I5)
 1113 FORMAT (1X,3X,I2,')',6F9.3,I5,'   ',$)
 1014 FORMAT (//' Enter the numbers of the parameters to be',
     +          ' varied:'/' (e.g. 125 varies Flux, Radius, and ',
     +          'Axial Ratio.)')
 1015 FORMAT (6I1)
 1016 FORMAT ( ' Sorry. You cannot vary A.R. for line comp. It will be',
     +          ' held fixed.')
 1017 FORMAT (' Sorry! For line component, A.R. will be set = 0.00 .')
 1018 FORMAT (' Note: A.R. set=0 for line component.')
      RETURN
      END
      SUBROUTINE BMODAP
C
C By Richard S. Simon
C
C Version 1:  27-Jul-1981
C Version 2:  04-Feb-1982         Add underlying model, if any
C
C This subroutine calculates model amplitudes and closure phases,
C given that IMVIS and REVIS have been found by BVIS.
C
C Reorganized for vectorization by TJP, 15-Mar-1988.
C modified for new BTRIANGLE by TJP, 5-Nov-1990.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
C
!     REAL MODPHA(MXREC,MXBAS), IMVIST
      REAL MODPHA(MXREC,MXBAS)
      REAL TVISR(MXREC,MXBAS), TVISI(MXREC,MXBAS)
      REAL AMP, X, Y
C
      AMP(X,Y) = SQRT(X*X + Y*Y)
C
C Calculate the complex visibilities of the model by summing the
C contributions of the components; convert to polar representation.
C
C First add in the contribution from the underlying model.
C
      IF (UNDMOD) THEN
          DO IB=1,NUMBAS
          DO ID=1, NUMREC
              TVISR(ID,IB) = UNREVIS(ID,IB)
              TVISI(ID,IB) = UNIMVIS(ID,IB)
          END DO
          END DO
      ELSE
          DO IB=1,NUMBAS
          DO ID=1, NUMREC
              TVISR(ID,IB) = 0.0
              TVISI(ID,IB) = 0.0
          END DO
          END DO
      END IF
C
C Add in the contributions from individual components.
C
      DO J=1, NCOMP
          DO IB=1,NUMBAS
          DO ID=1, NUMREC
              TVISR(ID,IB) = TVISR(ID,IB) + REVIS(J,ID,IB)
              TVISI(ID,IB) = TVISI(ID,IB) + IMVIS(J,ID,IB)
          END DO
          END DO
      END DO
C
C Convert to polar representation.
C
      DO IB=1,NUMBAS
      DO ID=1, NUMREC
          MODVIS(ID,IB) = AMP(TVISR(ID,IB), TVISI(ID,IB)) 
          IF (MODVIS(ID,IB) .EQ. 0.0) THEN
              MODPHA(ID,IB) = 0.
          ELSE
              MODPHA(ID,IB) = -ATAN2(TVISI(ID,IB),TVISR(ID,IB))
          END IF
      END DO
      END DO
C
C Calculate the closure phases of the model.
C
      DO IC=1,NUMTRI
      DO ID=1,NUMREC
          MODCLO(ID,IC) = MODPHA(ID,ICBSNO(1,IC)) +
     1                    MODPHA(ID,ICBSNO(2,IC)) - 
     2                    MODPHA(ID,ICBSNO(3,IC))
          IF (MODCLO(ID,IC) .LT. -PI .OR. MODCLO(ID,IC) .GT. PI) THEN
              MODCLO(ID,IC) = AMOD( MODCLO(ID,IC), TWOPI )
              IF (MODCLO(ID,IC) .LT. -PI) THEN
                  MODCLO(ID,IC) = MODCLO(ID,IC) + TWOPI
              ELSE IF (MODCLO(ID,IC) .GT. PI) THEN
                  MODCLO(ID,IC) = MODCLO(ID,IC) - TWOPI
              END IF
          END IF
      END DO
      END DO
C
      RETURN
      END
      SUBROUTINE BTRIANGLE
C-----------------------------------------------------------------------
C Finds which triangles are independent in a VLB data set.
C
C Revised by TJP 1990 Nov 5.
C     The program was incorrectly assuming the baselines were in
C     canonical order. It now uses the header information to determine
C     which baselines must be summed to get each closure phase.
C Revised by TJP 1990 Nov 5.
C     New algorithm for determining number of independent closure
C     phases. Each triangle which makes use of a baseline that has not
C     been used in a previous triangle is independent; otherwise it
C     can be expressed as a combination of the previous triangles.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
C
!     INTEGER   BASE(MXBAS), NSUSED, NBUSED, IT
!     LOGICAL   SUSED(MXSTA), BUSED(MXBAS)

      INTEGER   BASE(MXBAS), IT
      LOGICAL   BUSED(MXBAS)
C
C Make baseline labels for the NBAS baselines.
C
      DO IB=1,NBAS
          BASE(IB) = 100*NAVIS(IB) + NBVIS(IB)
      END DO
C
C Find the baseline numbers baseline numbers ICBSNO(*,NTRI) for 
C triangle NTRI by making baseline labels and looking them up in
C the list of available baselines.
C
      DO IT=1,NTRI
          ICBSNO(1,IT) = LOOKUP(100*NACLO(IT) + NBCLO(IT), BASE, NBAS)
          ICBSNO(2,IT) = LOOKUP(100*NBCLO(IT) + NCCLO(IT), BASE, NBAS)
          ICBSNO(3,IT) = LOOKUP(100*NACLO(IT) + NCCLO(IT), BASE, NBAS)
          IF (ICBSNO(1,IT).EQ.0 .OR. ICBSNO(2,IT).EQ.0 .OR.
     &        ICBSNO(3,IT).EQ.0) CALL ERROR('improper triangle list')
      END DO
C=    do i=1,numtri
C=      type *,icbsno(1,i),icbsno(2,i),icbsno(3,i)
C=    end do
C
C Find the independent triangles in each record, NINTRI(ID).
C
      DO ID=1,NUMREC
          DO IB=1,NBAS
              BUSED(IB) = .FALSE.
          END DO
          NINTRI(ID) = 0
          DO IT=1,NTRI
              IF (WTCLO(ID,IT) .GT. 0.0) THEN
                  IF (BUSED(ICBSNO(1,IT)) .AND.
     &                BUSED(ICBSNO(2,IT)) .AND.
     &                BUSED(ICBSNO(3,IT))) THEN
C                       -- not independent
                  ELSE
C                       -- independent
                      BUSED(ICBSNO(1,IT)) = .TRUE.
                      BUSED(ICBSNO(2,IT)) = .TRUE.
                      BUSED(ICBSNO(3,IT)) = .TRUE.
                      NINTRI(ID) = NINTRI(ID)+1
                  END IF
              END IF
          END DO
C=        type *, id, nintri(id)
      END DO
C
      RETURN
      END
      SUBROUTINE BWTDATA
C
C       By Richard S. Simon
C
C       This subroutine is part of program MODELFIT, and does the following:
C       1)  Compute the weights for each data point.
C       2)  Find the number of non-zero points in the data set.
C
C       Version N+1:    27-Jul-1981
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
      INTEGER COUNT
C
      DO 30 ID = 1, NUMREC
          NUMCLO(ID) = 0
   30 CONTINUE
C
C Find the amplitude weights.
C
      NZAMP = 0
      DO 60 IB = 1, NUMBAS
          COUNT = 0
          DO 50 ID = 1, NUMREC
            IF (WTVIS(ID,IB) .GT. 0.0) THEN
              COUNT = COUNT + 1
              WTVIS(ID,IB) = 1. / (WTVIS(ID,IB))**2
            ENDIF
   50     CONTINUE
          NZVIS(IB) = COUNT
          NZAMP = NZAMP + COUNT
   60 CONTINUE
C
C Find the weights for the closure phase data, if any.
C
      DO 80 IC = 1, NUMTRI
          COUNT = 0
          DO 70 ID = 1, NUMREC
            IF (WTCLO(ID,IC) .GT. 0.0) THEN
              COUNT = COUNT + 1
              NUMCLO(ID) = NUMCLO(ID) + 1
              WTCLO(ID,IC) = 1./ (WTCLO(ID,IC))**2
            ENDIF
   70     CONTINUE
          NZCLO(IC) = COUNT
   80 CONTINUE
      TNZCLO = 0.
      DO 90 ID = 1,NUMREC
          IF (NUMCLO(ID) .GT. 0) THEN
            DOWNWT(ID) = REAL(NINTRI(ID)) / REAL(NUMCLO(ID))
            TNZCLO = TNZCLO + NINTRI(ID)
          ELSE
            DOWNWT(ID) = 0
          ENDIF
   90 CONTINUE
      TNZDAT = NZAMP + TNZCLO
C
      RETURN
      END
      SUBROUTINE BVIS(J)
      INTEGER J
C
C By Richard S. Simon
C
C Finds the contribution to the complex visibility from a single model
C component.  Most of MODELFIT's cpu time is used in this routine, which
C must therefore be coded carefully. Recoded 14-Mar-1989 by TJP to
C put the loops inside the switch on component type; this may improve
C vectorization.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
C
      REAL C1
      PARAMETER (C1=-3.559707)
      INTEGER IB, ID
      REAL SPHI, CPHI, SX, CX, COMVIS, COMPHA, QQ, XX
C
      Q(A,SPHI,CPHI,R,U,V)= TWOPI*SQRT((V*CPHI+U*SPHI)**2
     1+ (R*(U*CPHI-V*SPHI))**2) * A
C
      SPHI = SIN(RPHI(J))
      CPHI = COS(RPHI(J))
      SX = TWOPI*RADIUS(J)*SIN(RTHETA(J))
      CX = TWOPI*RADIUS(J)*COS(RTHETA(J))
      IF (AXIS(J).EQ.0.0) THEN
          DO IB=1,NUMBAS
          DO ID=1,NUMREC
              COMPHA = SX*UDATA(ID,IB) + CX*VDATA(ID,IB)
              COMVIS = FLUX(J)
              REVIS(J,ID,IB)  = COMVIS*COS(COMPHA)
              IMVIS(J,ID,IB)  = COMVIS*SIN(COMPHA)
          END DO
          END DO
C
      ELSE IF (TYPE(J) .EQ. 1) THEN
          DO IB=1,NUMBAS
          DO ID=1,NUMREC
              COMPHA = SX*UDATA(ID,IB) + CX*VDATA(ID,IB)
              COMVIS = FLUX(J) * (EXP (C1 * AXIS(J)**2 *
     1          ((VDATA(ID,IB)*CPHI + UDATA(ID,IB)*SPHI)**2 +
     2          (RATIO(J) * (UDATA(ID,IB)*CPHI-VDATA(ID,IB)*SPHI))**2)))
              REVIS(J,ID,IB)  = COMVIS*COS(COMPHA)
              IMVIS(J,ID,IB)  = COMVIS*SIN(COMPHA)
          END DO
          END DO
C
      ELSE IF (TYPE(J) .EQ. 2) THEN
          DO IB=1,NUMBAS
          DO ID=1,NUMREC
              COMPHA = SX*UDATA(ID,IB) + CX*VDATA(ID,IB)
              QQ = 0.5 * Q(AXIS(J),SPHI,CPHI,RATIO(J),
     1               UDATA(ID,IB),VDATA(ID,IB))
              IF (ABS(QQ).LT.0.01) THEN
                  COMVIS = FLUX(J)*(1.0 - QQ*QQ/8. + QQ*QQ*QQ*QQ/192.)
              ELSE
                  COMVIS = 2. * FLUX(J) * BESJ1(QQ)/QQ
              END IF
              REVIS(J,ID,IB)  = COMVIS*COS(COMPHA)
              IMVIS(J,ID,IB)  = COMVIS*SIN(COMPHA)
          END DO
          END DO
C
      ELSE IF (TYPE(J) .EQ. 3) THEN
          DO IB=1,NUMBAS
          DO ID=1,NUMREC
              COMPHA = SX*UDATA(ID,IB) + CX*VDATA(ID,IB)
              QQ = 0.5 * Q(AXIS(J),SPHI,CPHI,RATIO(J),UDATA(ID,IB),
     1             VDATA(ID,IB))
              IF (ABS(QQ).LT.0.01) THEN
                  COMVIS = FLUX(J)*(1.0 - QQ*QQ/10. + QQ*QQ*QQ*QQ/280.)
              ELSE
                  COMVIS = 3. * FLUX(J) * (SIN(QQ)-QQ*COS(QQ)) /
     1               (QQ*QQ*QQ)
              END IF
              REVIS(J,ID,IB)  = COMVIS*COS(COMPHA)
              IMVIS(J,ID,IB)  = COMVIS*SIN(COMPHA)
          END DO
          END DO

      ELSE IF (TYPE(J) .EQ. 4) THEN
          DO IB=1,NUMBAS
          DO ID=1,NUMREC
              COMPHA = SX*UDATA(ID,IB) + CX*VDATA(ID,IB)
              COMVIS = FLUX(J) * BESJ0(Q(AXIS(J),SPHI,
     1          CPHI,RATIO(J),UDATA(ID,IB),VDATA(ID,IB))/2.0)
              REVIS(J,ID,IB)  = COMVIS*COS(COMPHA)
              IMVIS(J,ID,IB)  = COMVIS*SIN(COMPHA)
          END DO
          END DO
C
      ELSE IF (TYPE(J) .EQ. 5) THEN
          DO IB=1,NUMBAS
          DO ID=1,NUMREC
              COMPHA = SX*UDATA(ID,IB) + CX*VDATA(ID,IB)
              XX = (UDATA(ID,IB)*SPHI + VDATA(ID,IB)*CPHI)*PI*AXIS(J)
              IF (ABS(XX).LT.0.01) THEN
                  COMVIS = FLUX(J)*(1.0 - XX*XX/6. + XX*XX*XX*XX/120.)
              ELSE
                  COMVIS = FLUX(J) * SIN(XX)/XX
              END IF
              REVIS(J,ID,IB)  = COMVIS*COS(COMPHA)
              IMVIS(J,ID,IB)  = COMVIS*SIN(COMPHA)
          END DO
          END DO
C
      ELSE
          CALL ERROR ('Internal error in MODELFIT (BVIS).')
      END IF
C
      RETURN
      END
      SUBROUTINE FIXMOD
C
C       By Richard S. Simon
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
C
      DO 10 J=1,NCOMP
          IF (RADIUS(J) .LT. 0.) THEN
              RADIUS(J) = -RADIUS(J)
              RTHETA(J) =  RTHETA(J) + PI
          END IF
          RTHETA(J) = AMOD(RTHETA(J),TWOPI)
          THETA(J) = RTHETA(J)/DEGRAD
          AXIS(J) = ABS(AXIS(J))
          RATIO(J) = ABS(RATIO(J))
          IF (RATIO(J) .GT. 1.) THEN
              AXIS(J)  = AXIS(J)* RATIO(J)
              RATIO(J) = 1. / RATIO(J)
              RPHI(J)  = RPHI(J) + HALFPI
          END IF
          RPHI(J) = AMOD(RPHI(J),PI)
          PHI(J) = RPHI(J)/DEGRAD
  10  CONTINUE
C
      RETURN
      END
      SUBROUTINE GRADLS
C
C By Richard S. Simon             July 29, 1981
C
C This subroutine is loosely based on the subroutine GRADLS in
C "Data Reduction and Error Analysis for the Physical Sciences" by
C P. R. Bevington (1969), pg. 221.
C By moving along gradient of A.F., it minimizes the A.F.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
      REAL GRAD(6,MXMOD)
!     LOGICAL QUERY
C
      METHOD = 'Gradient search'

	
      AFLIM = 0.01
      DO 10 J=1,NCOMP
          DELTAP(1,J) = 0.05*FLUX(J)
          DELTAP(2,J) = 0.05*RADIUS(J) + 0.05
          DELTAP(3,J) = 5.*DEGRAD
          DELTAP(4,J) = 0.05*AXIS(J) + 0.05
          IF (RATIO(J) .GT. 0.5) THEN
              DELTAP(5,J) = -0.05
          ELSE
              DELTAP(5,J) =  0.05
          END IF
          DELTAP(6,J) = 5.*DEGRAD
   10 CONTINUE
C
      DO 210 ITER = 1, MAXIT
          OLDAF = TOTLAF
          AF1   = TOTLAF
          SUM   = 0.

C
C         Find components of gradient:



          DO 39 J=1,NCOMP
            DO 38 K=1,6
              IF(VARY(K,J)) THEN
                DELTA = 0.1 * DELTAP(K,J)
                PARM(J,K) = PARM(J,K) + DELTA
                CALL BVIS(J)
                CALL BMODAP
                CALL BAGRFAC
                PARM(J,K) = PARM(J,K) - DELTA
                GRAD(K,J) = AF1 - TOTLAF
                SUM = SUM + GRAD(K,J)*GRAD(K,J)
              ENDIF
   38       CONTINUE
   39     CONTINUE


          IF (SQRT(SUM) .EQ. 0.) GO TO 220
C
C         Normalize the gradient components and change each variable parameter.


	
          DO 52 J = 1,NCOMP
            DO 50 K = 1,6
              IF (VARY(K,J)) THEN
                GRAD(K,J) = DELTAP(K,J)*GRAD(K,J)/SQRT(SUM)
C               Move to a new point.
                PARM(J,K) = PARM(J,K) + GRAD(K,J)
              ENDIF
   50       CONTINUE
            CALL BVIS(J)
   52     CONTINUE
C
          CALL BMODAP
          CALL BAGRFAC

	icount=0

	do while (AF1.GT.TOTLAF.and.icount.le.100)

	icount=icount+1


              DO 53 J=1,NCOMP
                DO 54 K=1,6
                  IF (VARY(K,J)) THEN
                    GRAD(K,J) = GRAD(K,J) * 2.
                    PARM(J,K) = PARM(J,K) +GRAD(K,J)
                  ENDIF
   54           CONTINUE
                CALL BVIS(J)
   53         CONTINUE

              CALL BMODAP
              CALL BAGRFAC

!	write(*,*) 'do while...icount,AF1,TOTLAF ',icount,AF1,TOTLAF

	end do

C
C         Make sure AF decreases.

          IF (AF1 .LE. TOTLAF) THEN
            DO 68 NBACK = 1, 15
C             Moved too far, so decrease step size.
C             Moved too far, so backup in steps of 1/2, until AF has decreased
C             to less than its original value, then rearrange parameters so that
C             it looks like step size was correct.
!	  write(*,*) 'Moved too far, so decrease ...'
              AF2 = TOTLAF
              DO 64 J=1,NCOMP
                DO 62 K=1,6
                  IF (VARY(K,J)) THEN
                    GRAD(K,J) = GRAD(K,J) / 2.
                    PARM(J,K) = PARM(J,K) - GRAD(K,J)
                    DELTAP(K,J) = DELTAP(K,J) / 2.
                  ENDIF
   62           CONTINUE
                CALL BVIS(J)
   64         CONTINUE
              CALL BMODAP
              CALL BAGRFAC
              IF (TOTLAF .LT. AF1) THEN
                SAVE = AF2
                AF2 = TOTLAF
                TOTLAF = SAVE
                DO 66 J = 1,NCOMP
                  DO 65 K = 1, 6
                    IF (VARY(K,J)) PARM(J,K) = PARM(J,K) + GRAD(K,J)
   65             CONTINUE
   66           CONTINUE
                GO TO 80
              ENDIF
   68       CONTINUE
            GO TO 200
          ENDIF
C
C         Increment parameters until AF starts to increase.
          AF2 = TOTLAF
   70     DO 72 J = 1, NCOMP
            DO 71 K = 1,6
              IF (VARY(K,J)) PARM(J,K) = PARM(J,K) + GRAD(K,J)
   71       CONTINUE
            CALL BVIS(J)
   72     CONTINUE
          CALL BMODAP
          CALL BAGRFAC
          IF (TOTLAF .LT. AF2) THEN
            AF1 = AF2
            AF2 = TOTLAF
!           GO TO 70  ! this stops repetitive loop 
          ENDIF




C
C         Find minimum of parabola defined by last three points
   80     IF (TOTLAF .GT. AF2) THEN
            DELTA = 1./ (1.+(AF1-AF2)/(TOTLAF-AF2)) + 0.5
          ELSE
C           Backup if AF hasn't decreased
            DELTA = 1.
          ENDIF




          DO 93 J = 1,NCOMP
            DO 92 K = 1,6
              IF (VARY(K,J)) PARM(J,K) = PARM(J,K)-GRAD(K,J)*DELTA
   92       CONTINUE
            CALL BVIS(J)
   93     CONTINUE
          CALL BMODAP
          CALL BAGRFAC
C
          IF (TOTLAF .GT. AF2) THEN
C           Model diverged, so backup to lowest minimum.
            DO 102 J = 1, NCOMP
              DO 101 K = 1,6
                IF(VARY(K,J)) PARM(J,K) = PARM(J,K)+GRAD(K,J)*(DELTA-1.)
  101         CONTINUE
              CALL BVIS(J)
  102       CONTINUE
            CALL BMODAP
            CALL BAGRFAC
          ENDIF
C
  200     CONTINUE
C         -- Print current model parameters and fit
          JITER = ITER
          CALL BAFOUTA

C
C         If AF doesn't change significantly by 2nd iteration, quit here




          IF(ITER.GT.1 .AND. (OLDAF-TOTLAF)/OLDAF .LT. AFLIM .AND.
     +    OLDAF .GT. TOTLAF) THEN

!            IF (QUERY('Convergence is slow. Continue? (Y or N): ')) THEN
!                AFLIM = AFLIM/2.
!            ELSE
!                GOTO 220
!            END IF

                GOTO 220

          ENDIF

          IF (CCFLAG) GO TO 225

  210 CONTINUE

      CALL PUTOUT(' ')
      CALL PUTOUT('Iteration halted after maximum no. '//
     1            'of iterations along gradient.')
      GO TO 230
  220 CALL PUTOUT(' ')
      CALL PUTOUT('Iteration halted;  model seems to have '//
     1            'converged along gradient.')
      GO TO 230
  225 CALL PUTOUT(' ')
      CALL PUTOUT('Iteration halted by user.')
      CALL CTRLCEN
  230 CALL FIXMOD
      RETURN
C
      END
      SUBROUTINE GRIDLS
C
C       By Richard S. Simon             July 27, 1981
C
C       This subroutine is based on the subroutine GRIDLS in
C       "Data Reduction and Error Analysis for the Physical Sciences" by
C       P. R. Bevington (1969), pg. 212.
C       By trial and error, it minimizes the A.F.
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
!     LOGICAL QUERY
C
      METHOD = 'BRUTE FORCE !!!'
      AFLIM = 0.003*AFLIM
      DO 10 J=1,NCOMP
          DELTAP(1,J) = 0.1*FLUX(J)
          DELTAP(2,J) = 0.1*RADIUS(J) + 0.1
          DELTAP(3,J) = 5.0*DEGRAD
          DELTAP(4,J) = 0.1*AXIS(J)
          IF (RATIO(J) .GT. 0.5) THEN
              DELTAP(5,J) = -0.1
          ELSE
              DELTAP(5,J) =  0.1 * RATIO(J) + .05
          END IF
          DELTAP(6,J) = 10.*DEGRAD
   10 CONTINUE
C
      DO 210 ITER = 1,MAXIT
          OLDAF = TOTLAF
C
          DO 200 J=1,NCOMP
            DO 190 K=1,6
              IF(VARY(K,J)) THEN
                DELTA = DELTAP(K,J)
                AF1 = TOTLAF
                PREAF  = TOTLAF
                PREPRM = PARM(J,K)
                PREDEL = DELTA
                PARM(J,K) = PREPRM + DELTA
                CALL BVIS(J)
                CALL BMODAP
                CALL BAGRFAC
                AF2 = TOTLAF
C               -- Reverse direction of search if AF increasing
                IF (AF2 .GT. AF1) THEN
                  DELTA = -DELTA
                  PARM(J,K) = PARM(J,K) + DELTA
                  SAVE = AF1
                  AF1 = AF2
                  AF2 = SAVE
                ENDIF
C               -- Increment PARM(J,K) until AF increases
                FN = 0.
   60           FN = FN + 1.
                PARM(J,K) = PARM(J,K) + DELTA
                CALL BVIS(J)
                CALL BMODAP
                CALL BAGRFAC
                IF (TOTLAF .LT. AF2) THEN
                  AF1 = AF2
                  AF2 = TOTLAF
                  GO TO 60
                ELSEIF (TOTLAF .GT. AF2) THEN
C                 Find minimum of parabola defined by last three points
                  DELTA = DELTA * (1./(1.+(AF1-AF2)/(TOTLAF-AF2))+.5)
                  PARM(J,K) = PARM(J,K) - DELTA
                  DELTAP(K,J) = DELTAP(K,J) * FN/3.
C                 SIGMAP(K,J) = DELTAP(K,J) *
C     1           SQRT(2./((TNZDAT-NVPAR)*(TOTLAF-2.*AF2+AF1)))
                ENDIF
                CALL BVIS(J)
C               -- AF for final set of parameters
                CALL BMODAP
                CALL BAGRFAC
                IF (TOTLAF .GE. PREAF) THEN
C                 Model diverged, so reset model and decrease step size.
                  PARM(J,K) = PREPRM
                  DELTAP(K,J) = PREDEL/5.
                  CALL BVIS(J)
                  CALL BMODAP
                  CALL BAGRFAC
                ENDIF
              ENDIF
              IF (CCFLAG) GO TO 225
  190       CONTINUE
  200     CONTINUE
C         -- Print current model parameters and fit
          JITER = ITER
          CALL BAFOUTA
C
C If AF doesn't change significantly by 4th iteration, quit here.
C
          IF (ITER.GT.3 .AND. (OLDAF-TOTLAF)/OLDAF .LT. AFLIM .AND.
     +        OLDAF .GE. TOTLAF) THEN

!            IF (QUERY('Convergence is slow. Continue? (Y or N): ')) THEN
!                  AFLIM = AFLIM/2.
!             ELSE
!                  GOTO 220
!             END IF

	    GOTO220

          END IF
          OLDAF = TOTLAF
  210 CONTINUE
C
      CALL PUTOUT(' ')
      CALL PUTOUT('Iteration halted after maximum no. of iterations.')
      GOTO 230
C
  220 CALL PUTOUT(' ')
      CALL PUTOUT('Iteration halted;  model seems to have converged.')
      GOTO 230
C
  225 CALL PUTOUT(' ')
      CALL PUTOUT('Iteration halted after an <interrupt>.')
      CALL CTRLCEN
      GOTO 230
C
  230 CALL FIXMOD
      RETURN
C
      END
      SUBROUTINE UNDERMOD
C
C By Richard S. Simon
C
C This subroutine is used by modelfit to calculate, store, and
C retrieve the contribution to a model fit from an underlying model.
C This underlying model is held constant while a few additional
C components may be varied in the usual way.
C
C Version 01:  04-Feb-1982
C-----------------------------------------------------------------------
      INCLUDE 'fakesat.inc'
C
      REAL  UFLUX(MXUNDMOD),URADIUS(MXUNDMOD),URTHETA(MXUNDMOD)
      REAL  UAXIS(MXUNDMOD),URATIO(MXUNDMOD),URPHI(MXUNDMOD)
      INTEGER ITYPE(MXUNDMOD)
      REAL C1
      PARAMETER (C1=-3.559707)
      LOGICAL QUERY
      INTEGER GETIN
C
C The following equivalence is strictly to save storage space
C
C     EQUIVALENCE (UFLUX(1),IMVIS(1)),(URADIUS(1),IMVIS(MXUNDMOD+1)),
C    1(URTHETA(1),IMVIS(2*MXUNDMOD+1)),(UAXIS(1),IMVIS(3*MXUNDMOD+1)),
C    2(URATIO(1),IMVIS(4*MXUNDMOD+1)),(URPHI(1),IMVIS(5*MXUNDMOD+1)),
C    3(ITYPE(1),IMVIS(6*MXUNDMOD+1))
C
      Q(A,SPHI,CPHI,R,U,V) = TWOPI*SQRT((V*CPHI+U*SPHI)**2
     1                      + (R*(U*CPHI-V*SPHI))**2) * A
C
C Find out if underlying model is wanted:
C
   10 CALL PUTOUT(' ')
!      UNDMOD = QUERY('Should part of input model be '//
!     1               'a separate (constant) model? (Y or N): ')
       UNDMOD = .FALSE.
      IF (.NOT.UNDMOD) RETURN
C
C Determine if underlying model has already been computed;  then
C get that, or a 'new' underlying model.
C
      CALL PUTOUT(' ')
      IF (QUERY('Has the underlying model been computed '//
     1          'before?  (Y or N): ')) THEN
C         -- Try and read in contribution from underlying model:
          CALL PUTOUT(' ')
   20     IER = GETIN(UNDDSN, 'Filename for contribution from '//
     1                'underlying model: ', L)
          IF (IER.NE.1) STOP
          OPEN  (UNIT=INUND,FORM='UNFORMATTED',ERR=20,
     1    STATUS='OLD',NAME=UNDDSN)
          DO 30 I=1,MXREC
            READ (INUND,ERR=50,END=40) (UNIMVIS(I,J), J=1,NBAS)
            READ (INUND,ERR=50,END=50) (UNREVIS(I,J), J=1,NBAS)
   30     CONTINUE
          I = MXREC + 1
          CALL PUTOUT('Warning:  Maximum number of records being'//
     1                ' used.')
   40     IREC = I-1
          IF (IREC .EQ. NUMREC) THEN
            CALL PUTOUT('Contribution from underlying model has'//
     1      ' successfully been read in.')
            UNDMOD = .TRUE.
            CLOSE (UNIT=INUND)
            RETURN
          ELSE
            CALL ERROR('Underlying model file does not have the'//
     1      ' right number of data records.')
          ENDIF
C
   50     CLOSE (UNIT=INUND)
          CALL PUTOUT(' ')
          UNDMOD = QUERY('Something''s wrong with the underlying'//
     1                   ' model file.  Try again? (Y or N): ')
          IF (UNDMOD) GOTO 10
C
      END IF
C
C Get a new input model, read it in, and find contribution.
C
      CALL PUTOUT(' ')
   60 IER = GETIN(UNDDSN, 'Filename for underlying model: ', L)
      IF (IER.NE.1) STOP
      OPEN  (UNIT=INUND,FORM='FORMATTED',ERR=60,
     1       STATUS='OLD',NAME=UNDDSN)
      CALL PUTOUT(' ')
   70 IER = GETIN(OUTUNDDSN,
     1            'Filename for output from underlying model: ', L)
      IF (IER.NE.1) STOP
      OPEN  (UNIT=OUTUND,FORM='UNFORMATTED',ERR=70,
     1       STATUS='NEW',NAME=OUTUNDDSN)
C
C Read in the the underlying model.
C
      FLXSUM = 0.
      DO 150 I=1,MXUNDMOD
          CALL GTMODL (INUND,ITYPE(I),UFLUX(I),URADIUS(I),UTHETA,
     1    UAXIS(I),URATIO(I),UPHI, *155, 0)
          IF (UFLUX(I) .EQ. 0.0) GO TO 155
          FLXSUM = FLXSUM + UFLUX(I)
          URTHETA(I) = UTHETA * DEGRAD
          URPHI(I)   = UPHI * DEGRAD
          IF (ITYPE(I) .EQ. 0) ITYPE(I) = 1
  150 CONTINUE
      WRITE (OUTC,650) MXUNDMOD
      I = MXUNDMOD + 1
  155 NUMUNDMOD = I-1
      IF (FLXSUM .EQ. 0.0) CALL ERROR('Model has zero total flux')
C
C Calculate the contribution from the underlying model, store it in
C the arrays UNIMVIS and UNREVIS, and write UNIMVIS and UNREVIS to
C the output file OUTUNDDSN.
C
      DO 350 IB = 1, NBAS
          DO 325 ID = 1, NUMREC
            IF (WTVIS(ID,IB).LE.0.) GO TO 325
            UNREVIS(ID,IB) = 0.0
            UNIMVIS(ID,IB) = 0.0
            DO 300  J=1,NUMUNDMOD
              COMPHA = TWOPI*URADIUS(J) * (UDATA(ID,IB)*SIN(URTHETA(J))
     1        + VDATA(ID,IB)*COS(URTHETA(J)))
C
C             Find the complex visibility amplitude:
              IF (UAXIS(J) .EQ. 0.0) THEN
                COMVIS = UFLUX(J)
              ELSEIF (ITYPE(J) .EQ. 1) THEN
                SPHI   = SIN(URPHI(J))
                CPHI   = COS(URPHI(J))
                COMVIS = UFLUX(J) * (EXP (C1 * UAXIS(J)**2 *
     1          ((VDATA(ID,IB)*CPHI + UDATA(ID,IB)*SPHI)**2 +
     2          (URATIO(J)*(UDATA(ID,IB)*CPHI-VDATA(ID,IB)*SPHI))**2)))
              ELSEIF (TYPE(J) .EQ. 2) THEN
                SPHI   = SIN(URPHI(J))
                CPHI   = COS(URPHI(J))
                QQ = Q(UAXIS(J),SPHI,CPHI,URATIO(J),
     1               UDATA(ID,IB),VDATA(ID,IB))
                QQ = QQ / 2.0   ! Thus, axis is diameter
                IF (ABS(QQ).LT.0.01) THEN
                  COMVIS = UFLUX(J)*(1.0 - QQ*QQ/8. + QQ*QQ*QQ*QQ/192.)
                ELSE
                  COMVIS = 2. * UFLUX(J) * BESJ1(QQ)/QQ
                END IF
              ELSEIF (ITYPE(J) .EQ. 3) THEN
                SPHI   = SIN(URPHI(J))
                CPHI   = COS(URPHI(J))
                QQ = Q(UAXIS(J),SPHI,CPHI,URATIO(J),
     1               UDATA(ID,IB),VDATA(ID,IB))
                QQ = QQ / 2.0   ! Thus, axis is diameter
                IF (ABS(QQ).LT.0.01) THEN
                  COMVIS = UFLUX(J)*(1.0 - QQ*QQ/10. + QQ*QQ*QQ*QQ/280.)
                ELSE
                  COMVIS = 3. * UFLUX(J) * (SIN(QQ)-QQ*COS(QQ)) /
     1               (QQ*QQ*QQ)
                END IF
              ELSEIF (ITYPE(J) .EQ. 4) THEN
                SPHI   = SIN(URPHI(J))
                CPHI   = COS(URPHI(J))
                COMVIS = UFLUX(J) * BESJ0(Q(UAXIS(J),SPHI,
     1          CPHI,URATIO(J),UDATA(ID,IB),VDATA(ID,IB))/2.0)
              ELSEIF (TYPE(J) .EQ. 5) THEN
                SPHI   = SIN(URPHI(J))
                CPHI   = COS(URPHI(J))
                XX = (UDATA(ID,IB)*SPHI + VDATA(ID,IB)*CPHI)*PI*UAXIS(J)
                IF (ABS(XX).LT.0.01) THEN
                  COMVIS = UFLUX(J)*(1.0 - XX*XX/6. + XX*XX*XX*XX/120.)
                ELSE
                  COMVIS = UFLUX(J) * SIN(XX)/XX
                END IF
              ELSE
                CALL ERROR (' Illegal component type in model.')
              ENDIF
C
              UNREVIS(ID,IB)  = UNREVIS(ID,IB) + COMVIS*COS(COMPHA)
              UNIMVIS(ID,IB)  = UNIMVIS(ID,IB) + COMVIS*SIN(COMPHA)
  300       CONTINUE
  325     CONTINUE
  350 CONTINUE
C
C Write the contribution from the underlying model to the output file.
C
      CALL PUTOUT(' ')
      CALL PUTOUT('Model calculation done.')
      DO 400 I=1,NUMREC
          WRITE (OUTUND) (UNIMVIS(I,J), J=1,NBAS)
          WRITE (OUTUND) (UNREVIS(I,J), J=1,NBAS)
  400 CONTINUE
      CLOSE (UNIT=INUND)
      CLOSE (UNIT=OUTUND)
      CALL PUTOUT('Contribution from underlying model written '//
     1            'to file '//OUTUNDDSN)
      WRITE (OUTC,1001) '0There were ',NUMUNDMOD,' components in the',
     1' underlying model.'
      UNDMOD = .TRUE.
      RETURN
C
  650 FORMAT (' ++WARNING++ Model truncated after ',I5,' components.')
 1001 FORMAT (A,I5,A,A)
      END


         subroutine FITMOD2(MODIN,MODOUT,MODTRUE,MODVARYIN,
     1   NUMFIT1,NUMFIT2,TOTLAF1,TOTLAF2,TOTLAF3,CIRCULAR)

        REAL    MODIN(6),MODOUT(7),TOTLAF1,TOTLAF2,TOTLAF3
        REAL    MODTRUE(6)
        INTEGER NUMFIT1,NUMFIT2
        LOGICAL  MODVARY(6),MODVARYIN(6),CIRCULAR,GRADSRCH

!	  write(*,*) 'enter FITMOD2'
!	  write(*,*) 'MODIN: '
!	  write(*,*) (MODIN(var),var=1,6)
!	  write(*,*) 'MODOUT: '
!	  write(*,*) (MODOUT(var),var=1,6)
!	  write(*,*) 'MODTRUE: '
!	  write(*,*) (MODTRUE(var),var=1,6)
!	  write(*,*) 'MODVARYIN: '
!	  write(*,*) (MODVARYIN(var),var=1,6)
!	  write(*,*) 'NUMFIT1,NUMFIT2,TOTLAF1,TOTLAF2,TOTLAF3,CIRCULAR'
!	  write(*,*)  NUMFIT1,NUMFIT2,TOTLAF1,TOTLAF2,TOTLAF3,CIRCULAR

        GRADSRCH=.true.   ! .true.  = gradient search 
	                  ! .false. = grid search

	do var=1,6
         MODOUT(var)=MODIN(var)
	end do


	if(NUMFIT1.GE.1) then

	do var=1,NUMFIT1

	 if(TOTLAF3.GT.TOTLAF1) then

	  write(*,*) ' '
	  write(*,*) 'Gradient search: loop number: ',var
	  write(*,*) ' '

! vary just flux density and semi-major axis

	 if(MODVARYIN(1).and.MODVARYIN(4)) then

	 MODVARY(1)=.true.   ! vary flux density
	 MODVARY(2)=.false.  ! vary distance of component from origin
	 MODVARY(3)=.false.  ! vary PA of component from orgin
	 MODVARY(4)=.true.   ! vary semi-major axis of component
	 MODVARY(5)=.false.  ! vary axial ratio of component
	 MODVARY(6)=.false.  ! vary PA of component

!        GRADSRCH=.true.   ! .true.  = gradient search 
	                   ! .false. = grid search



         CALL FITMOD(MODIN(1),  MODIN(2),  MODIN(3),
     1               MODIN(4),  MODIN(5),  MODIN(6),
     2   MODOUT(1),MODOUT(2),
     3   MODOUT(3), MODOUT(4), 
     4   MODOUT(5), MODOUT(6),
     5               MODVARY(1),MODVARY(2),MODVARY(3),
     6               MODVARY(4),MODVARY(5),MODVARY(6),
     7               GRADSRCH,TOTLAF3)


	MODIN(1)=MODOUT(1)
	MODIN(4)=MODOUT(4)

!	 write(*,*) 'best fit model parameters :'

!	 write(*,*) MODOUT(1),MODOUT(2),
!     1   MODOUT(3), MODOUT(4),
!     2   MODOUT(5), MODOUT(6)

	 end if !if(MODVARYIN(1).and.MODVARYIN(4)) then


	if(.not.circular) then

	 if(MODVARYIN(5).and.MODVARYIN(6)) then

! vary axial ratio and PA :

	 MODVARY(1)=.false.  ! vary flux density
	 MODVARY(2)=.false.  ! vary distance of component from origin
	 MODVARY(3)=.false.  ! vary PA of component from orgin
	 MODVARY(4)=.false.  ! vary semi-major axis of component
	 MODVARY(5)=.true.   ! vary axial ratio of component
!	 MODVARY(5)=.false.  ! vary axial ratio of component
	 MODVARY(6)=.true.   ! vary PA of component

!        GRADSRCH=.true.   ! .true.  = gradient search 
	                   ! .false. = grid search

         CALL FITMOD(MODIN(1),  MODIN(2),  MODIN(3),
!    1               MODIN(4),  MODIN(5)/2.0,  MODIN(6),
     1               MODIN(4),  MODIN(5),  MODIN(6),
     2   MODOUT(1),MODOUT(2),
     3   MODOUT(3), MODOUT(4), 
     4   MODOUT(5), MODOUT(6),
     5               MODVARY(1),MODVARY(2),MODVARY(3),
     6               MODVARY(4),MODVARY(5),MODVARY(6),
     7               GRADSRCH,TOTLAF3)

	MODIN(5)=MODOUT(5)
	MODIN(6)=MODOUT(6)

!	 write(*,*) 'best fit model parameters :'

!	 write(*,*) MODOUT(1),MODOUT(2),
!     1   MODOUT(3), MODOUT(4),
!     2   MODOUT(5), MODOUT(6)

	end if 	 ! if(MODVARYIN(5).and.MODVARYIN(6)) then

! vary semi-axis and axial ratio

	if(MODVARYIN(4).and.MODVARYIN(5)) then

	 MODVARY(1)=.false.  ! vary flux density
	 MODVARY(2)=.false.  ! vary distance of component from origin
	 MODVARY(3)=.false.  ! vary PA of component from orgin
	 MODVARY(4)=.true.   ! vary semi-major axis of component
	 MODVARY(5)=.true.   ! vary axial ratio of component
	 MODVARY(6)=.false.  ! vary PA of component

!        GRADSRCH=.true.   ! .true.  = gradient search 
	                   ! .false. = grid search

         CALL FITMOD(MODIN(1),  MODIN(2),  MODIN(3),
     1               MODIN(4),  MODIN(5),  MODIN(6),
     2   MODOUT(1),MODOUT(2),
     3   MODOUT(3), MODOUT(4), 
     4   MODOUT(5), MODOUT(6),
     5               MODVARY(1),MODVARY(2),MODVARY(3),
     6               MODVARY(4),MODVARY(5),MODVARY(6),
     7               GRADSRCH,TOTLAF3)

	MODIN(4)=MODOUT(4)
	MODIN(5)=MODOUT(5)


!	 write(*,*) 'best fit model parameters :'

!	 write(*,*) MODOUT(1),MODOUT(2),
!     1   MODOUT(3), MODOUT(4),
!     2   MODOUT(5), MODOUT(6)

	end if !if(MODVARYIN(4).and.MODVARYIN(5)) then


! vary flux density and PA

	if(MODVARYIN(1).and.MODVARYIN(6)) then

	 MODVARY(1)=.true.   ! vary flux density
	 MODVARY(2)=.false.  ! vary distance of component from origin
	 MODVARY(3)=.false.  ! vary PA of component from orgin
	 MODVARY(4)=.false.  ! vary semi-major axis of component
	 MODVARY(5)=.false.  ! vary axial ratio of component
 	 MODVARY(6)=.true.   ! vary PA of component
!	 MODVARY(6)=.false.  ! vary PA of component

!        GRADSRCH=.true.   ! .true.  = gradient search 
	                   ! .false. = grid search

         CALL FITMOD(MODIN(1),  MODIN(2),  MODIN(3),
     1               MODIN(4),  MODIN(5),  MODIN(6),
     2   MODOUT(1),MODOUT(2),
     3   MODOUT(3), MODOUT(4), 
     4   MODOUT(5), MODOUT(6),
     5               MODVARY(1),MODVARY(2),MODVARY(3),
     6               MODVARY(4),MODVARY(5),MODVARY(6),
     7               GRADSRCH,TOTLAF3)

	MODIN(1)=MODOUT(1)
	MODIN(6)=MODOUT(6)

	end if !if(MODVARYIN(1).and.MODVARYIN(6)) then

	end if !if(.not.circular) then


	 write(*,*) 'best fit model parameters :'

	 write(*,*) MODOUT(1),MODOUT(2),
     1   MODOUT(3), MODOUT(4),
     2   MODOUT(5), MODOUT(6)

	end if   ! if(TOTLAF3.LE.TOTLAF1)

!	write(*,*) 'var, TOTLAF ',var, TOTLAF3


	end do

	else

	write(*,*) 'NUMFIT1 lt 1: NO grid search !'

	end if ! if(NUMFIT1.GE.1) then


! final iteration: use brute force !!!


	 if(NUMFIT2.GE.1) then

	do var=1,NUMFIT2

	  write(*,*) ' '
	  write(*,*) 'Brute force search: loop number: ',var
	  write(*,*) ' '

	  if(var.eq.1.or.TOTLAF3.gt.TOTLAF2) then

	 MODVARY(1)= MODVARYIN(1)   ! vary flux density
	 MODVARY(2)= MODVARYIN(2)   ! vary distance of component from origin
	 MODVARY(3)= MODVARYIN(3)   ! vary PA of component from orgin
	 MODVARY(4)= MODVARYIN(4)   ! vary semi-major axis of component
	 MODVARY(5)= MODVARYIN(5)   ! vary axial ratio of component
	 MODVARY(6)= MODVARYIN(6)   ! vary PA of component

	if(circular) then
	 MODVARY(5)=.false.   ! vary axial ratio of component
	 MODVARY(6)=.false.   ! vary PA of component
	end if


!        GRADSRCH=.false.   ! .true.  = gradient search 
	                    ! .false. = grid search

         CALL FITMOD(MODIN(1),  MODIN(2),  MODIN(3),
     1               MODIN(4),  MODIN(5),  MODIN(6),
     2   MODOUT(1),MODOUT(2),
     3   MODOUT(3), MODOUT(4), 
     4   MODOUT(5), MODOUT(6),
     5               MODVARY(1),MODVARY(2),MODVARY(3),
     6               MODVARY(4),MODVARY(5),MODVARY(6),
     7               .false.,TOTLAF3)

	MODIN(1)=MODOUT(1)
	MODIN(2)=MODOUT(2)
	MODIN(3)=MODOUT(3)
	MODIN(4)=MODOUT(4)
	MODIN(5)=MODOUT(5)
	MODIN(6)=MODOUT(6)

	  end if

!	write(*,*) 'Brute Force: var, TOTLAF ',var, TOTLAF3

	 end do ! do var=1,NUMFIT2

	 else

	  write(*,*) 'NUMFIT2 lt 1: NO brute search !'

	 end if !if(NUMFIT2.GE.1) then


	  MODOUT(7)=TOTLAF3

	  if(MODTRUE(5).eq.1.0) then
	    MODOUT(6)=MODTRUE(6)
	 end if

	  if(MODOUT(6).LT.0.0) then
	    MODOUT(6)=180.0+MODOUT(6)
	  end if

!	  write(*,*) 'exit FITMOD2'
!	  write(*,*) 'MODIN: '
!	  write(*,*) (MODIN(var),var=1,6)
!	  write(*,*) 'MODOUT: '
!	  write(*,*) (MODOUT(var),var=1,6)
!	  write(*,*) 'MODTRUE: '
!	  write(*,*) (MODTRUE(var),var=1,6)
!	  write(*,*) 'MODVARYIN: '
!	  write(*,*) (MODVARYIN(var),var=1,6)
!	  write(*,*) 'NUMFIT1,NUMFIT2,TOTLAF1,TOTLAF2,TOTLAF3,CIRCULAR'
!	  write(*,*)  NUMFIT1,NUMFIT2,TOTLAF1,TOTLAF2,TOTLAF3,CIRCULAR


	return
	end








