      subroutine ploteclip(filename,plotf,x1vp,x2vp,y1vp,y2vp,frac)

C This programs works with the ECLIPLOT option in the program
C FAKESAT. The ECLIPLOT option  produces a file: ecliplot.dat
C which lists for all the tracking stations the eclipses and
C the time at the center of the eclipse.
C Rows are:
C (1) Day Number in middle of eclipse
C (2) Eclipse Time (minutes)
C DWM 18-June-91

! convert from an interactive program to a subroutine
! DWM 28-Jul-93

      PARAMETER  (MAXECLIP=4000) !max number of eclipses

      character filename*21

      integer numecli,sumecli
      real x1vp,x2vp,y1vp,y2vp,frac
      real elength(MAXECLIP),etime(MAXECLIP)
      real x(MAXECLIP),y(MAXECLIP),left,right,top,bottom
      real ysort(MAXECLIP),nustart(MAXECLIP),nustop(MAXECLIP)
      real lplot,rplot,bplot,tplot,cumul(MAXECLIP)
!     real y2(MAXECLIP)
      real nuper,mper,eper,tstart(MAXECLIP),tstop(MAXECLIP)
      real nubatt(MAXECLIP),mbatt,estart,mstart,estop,mstop
      real ybatt(MAXECLIP),yper(MAXECLIP),tbatt(MAXECLIP)

C-gam real nustart(MAXECLIP),nustop(MAXECLIP)

      real nu1(MAXECLIP),nu2(MAXECLIP),nu3(MAXECLIP)
      real nu1plot,nu2plot,nu3plot
      real xplot(3),yplot(3),r2,r3
      real xplot2(4),yplot2(4),ang1,ang2
      real m1(MAXECLIP),m2(MAXECLIP),m3(MAXECLIP),inc,man
      character*80 title,plotf
      character*80 xlabel(10),ylabel(10),satname*9
      character*40 text(50),year*4
      logical sort,swop,use

      	pi=3.141592654
	dr=pi/180.0
	rd=1/dr

!	x1 = 0.05
!	x2 = 0.95
!	y1 = 0.05
!	y2 = 0.95

	x1 = 0.0
	x2 = 1.0
	y1 = 0.0
	y2 = 1.0


! aspect ratio required for plots

	aspect = 0.713

! since we are using pgvport2 need so scale text

	ascale = 0.7
	schtext=1.0*ascale

  	
300	continue		
 
!      write(*,*) 'What file contains ecliplot data ?'
!      write(*,*) '(usually ecliplot.dat)'
!      read(*,'(a)') filename

!        write(*,*) 'ecliplot: filename :'
!	write(*,'(a)') filename
!        write(*,*) 'ecliplot: plotf :'
!	write(*,'(a)') plotf

      
      open(1, file=filename, status='old',err=999)
      read(1,'(a)') satname
      read(1,*) a
      read(1,*) e
      read(1,*) inc
      read(1,*) ran
      read(1,*) aop
      read(1,*) man
      read(1,'(1x,a)') year
      read(1,*) tmin
      read(1,*) tmax

	 tmin_in = tmin
	 tmax_in = tmax


	iostat=0
	it=0 


	do while (iostat.eq.0)

	 if(it.ge.MAXECLIP) then

	  write(*,*) ' '
	  write(*,*) '**************WARNING*************************'
	  write(*,*) ' '
	  write(*,*) 'unable to plot all the eclipses that occurred'
          write(*,*) 'Only plotting first ',MAXECLIP,' eclipses'
	  write(*,*) ' '
	  write(*,*) '**********************************************'
	  write(*,*) ' '

	  tmax_in = etime(it)

	  goto 25

	 end if



	   it=it+1


	   read(1,*,iostat=iostat,end=25) 
     1     etime(it),elength(it),nustart(it),nustop(it)


!	   write(*,*) 
!    1     etime(it),elength(it),nustart(it),nustop(it)


	   if(it.eq.1) then
!	    tmin=etime(1)
!           tmax=etime(1)
	    emax=elength(1)
	   else
!	    if(etime(it).lt.tmin)   tmin=etime(it)
!	    if(etime(it).gt.tmax)   tmax=etime(it)
	    if(elength(it).gt.emax) emax=elength(it)
	   end if
	   
	end do

25	continue

	numecli = it-1

!	 write(*,*) 'number of eclipses: ', numecli

! DWM 25-Jan-95
! Don't like the way a suppressed timescale was being used !
! Plot full time range
!
	  tmin = tmin_in
	  tmax = tmax_in


700	continue

	tsat=1436.068167*((a/42164.16)**1.5)

!	write(*,*) 'Satellite period (mins) ',tsat
!	write(*,*) 'Satellite period (hrs) ',tsat/60.0

	 err=0.000001

!	write(*,*) 'Perigee operations: options'
!	write(*,*) '1=loss in terms of true anomlay'
!	write(*,*) '2=loss in terms of time'
!	write(*,*) 'which option ?'
!	read(*,*) ioptper

	 ioptper=2


	if(ioptper.eq.1) then
	  write(*,*) 'no observations when abs(true anomaly) less'
	  write(*,*) 'less than some critical value'
	  write(*,*) 'what is this critical value ?'
	  read(*,*) nuper

	  Eper=rd*2.0*atan(sqrt((1-e)/(1+e))*tan(0.5*nuper*dr))
	  Mper=Eper-(rd*e*sin(Eper*dr))
	  tper=(Mper/360.0)*tsat

!	 write(*,*) 'Eper,e,Mper,tper ',Eper,e,Mper,tper 

	 write(*,*) 'time lost (mins) due to perigee operations ',2.0*tper

	else

!	 write(*,*) 'no observations at the time centered on perigee'
!	 write(*,*) 'what is length (mins) of this time ?'
!	 read(*,*) tper

	 tper=0.0

	 tper=tper/2.0
	 Mper=(360.0/tsat)*tper

	 call KEP2(Mper,e,err,nuper)

!	 write(*,*) 'e,Mper,tper ',e,Mper,tper 

!	write(*,*) 'no observations when abs(true anomaly) is less than ',nuper

	end if

	  

	


!	write(*,*) 'what is battery re-charge time ?'
!	write(*,*) '(in units of eclipse time)'
!	write(*,*) '(EX: VSOP 22 GHz time=3.0)'
!	read(*,*) trecharge

	trecharge = 0.0


	  thalf=0.5*tsat


	 do it=1,numecli
	
	  Estart=rd*2.0*atan(sqrt((1-e)/(1+e))*tan(0.5*nustart(it)*dr))
	  Mstart=Estart-(rd*e*sin(Estart*dr))
	  tstart(it)=(Mstart/360.0)*tsat
	  Estop=rd*2.0*atan(sqrt((1-e)/(1+e))*tan(0.5*nustop(it)*dr))
	  Mstop=Estop-(rd*e*sin(Estop*dr))
	  tstop(it)=(Mstop/360.0)*tsat

!	  tbatt(it)=tstop(it)+trecharge*(elength(it))
	  tbatt(it)=tstart(it)+(1.0+trecharge)*(elength(it))


	 
	  Mbatt=360.0*(tbatt(it)/tsat)

	  if(trecharge.gt.0.0) then
	   call KEP2(Mbatt,e,err,nubatt(it))
	  else
	   nubatt(it)=nustop(it)
!	   tbatt(it) =tstop(it)
	   tbatt(it) =tstart(it)+elength(it)
	  end if

	   err2=2.0*rd*err

!	  diff=abs(nustop(it)-nubatt(it))
!	  if((nubatt(it).lt.nustop(it)).and.(diff.lt.err2)) then
!	    nubatt(it)=nustop(it)+err
!	  end if


	 end do


	
	t1=tmin
	t2=tmax

	iopt=0


!	write(*,*) 'options:'
!	write(*,*) '0=plot eclipse length vs day number'
!	write(*,*) '1=plot true anomaly vs day number ?'
!	write(*,*) '2=plot Mean anomaly vs day number ?'
!	write(*,*) 'which option ?'
!	read(*,*) iopt

	iopt = 0

	iopt2=0


200	continue


!	  write(*,*) 'min and max day numbers in data set are '
!	  write(*,*) tmin,tmax
!	  write(*,*) 'min and max day numbers now selected are'
!	  write(*,*) t1,t2

	 if(iopt2.eq.0) then
!	  write(*,*) 'do you want to change day numbers selected ?'
!	  write(*,*) '(1=yes)'
!	  read(*,*) ians1

	    ians1=0
	
	 end if

	 if((ians1.eq.1).or.(iopt2.eq.2)) then
	  write(*,*) 'min and max day numbers to select data ?'
	  read(*,*) t1
	  read(*,*) t2
	  ians1=0
	 end if



        sumecli=0
	averecli=0.0
	avperlost=0.0

	
	do i=1,numecli

!	   write(*,*) 'i,numecli,t1,t2,etime(i) ',i,numecli,t1,t2,etime(i)

	 if((etime(i).ge.t1).and.(etime(i).le.t2)) then 
	         sumecli=sumecli+1

!	   write(*,*) 'sumecli ', sumecli

	        x(sumecli)=etime(i)
	        y(sumecli)=elength(i)
                nu1(sumecli)=nustart(i)
                nu2(sumecli)=nustop(i)
                nu3(sumecli)=nubatt(i)
	        m1(sumecli)=360.0*tstart(i)/tsat
	        m2(sumecli)=360.0*tstop(i)/tsat
	        m3(sumecli)=360.0*tbatt(i)/tsat
	        if(m3(sumecli).gt.180.0) m3(sumecli)=m3(sumecli)-360.0
	        ybatt(sumecli)=(1.0+trecharge)*y(sumecli)

	        yper(sumecli)=0.0
 
! old algorithm: WRONG !
!
!	        if(tper.gt.tbatt(i)) then
!		  yper(sumecli)=(tper-tbatt(i))
!	        end if	        
!	        if(-tper.lt.tstart(i)) then
!		  yper(sumecli)=(tper+tstart(i))
!	        end if

	if(tstart(i).le.-tper) then
	 if(tbatt(i).le.-tper) yper(sumecli)=2*tper	         
	 if((tbatt(i).gt.-tper).and.(tbatt(i).lt.tper)) yper(sumecli)=tper-tbatt(i)
	end if

	if((tstart(i).gt.-tper).and.(tstart(i).lt.tper)) then
	 if(tbatt(i).le.(tsat-tper)) yper(sumecli)=tstart(i)+tper
	 if((tbatt(i).gt.-tper).and.(tbatt(i).lt.tper)) 
     1   yper(sumecli)=2*tper-(tbatt(i)-tstart(i))	         
	 if((tbatt(i).gt.(tsat-tper)).and.(tbatt(i).lt.(tsat+tper))) then
	   yper(sumecli)=tsat+2*tper-(tbatt(i)-tstart(i))
	 end if
	end if
	
	if((tstart(i).gt.tper).and.(tstart(i).lt.(tsat-tper))) then
	 if(tbatt(i).le.(tsat-tper)) yper(sumecli)=2*tper
	 if((tbatt(i).gt.(tsat-tper)).and.(tbatt(i).lt.(tsat+tper))) then
	   yper(sumecli)=(tsat+tper)-tbatt(i)
	 end if
	end if

!	write(*,*) 'x,tstart,tbatt,tper,yper '
!    1  ,x(i),tstart(i),tbatt(i),tper,yper(sumecli)

	          
	yper(sumecli)=yper(sumecli)+ybatt(sumecli)

	    avperlost=avperlost+yper(sumecli)

	        averecli=averecli+elength(i)	      
	      if(sumecli.eq.1) then
		  ymin=y(sumecli)
		  ymax=y(sumecli)
                  tymax=etime(i)
                  tymin=etime(i)
	      else
	        if(y(sumecli).lt.ymin) then
	           ymin=y(sumecli)
                   tymin=etime(i)
	        end if
	        if(y(sumecli).gt.ymax) then 
	         ymax=y(sumecli)
                 tymax=etime(i)
	        end if
	      end if
	  end if
	end do

	    timeav=t2-t1

	avperlost=100.0*(avperlost/(timeav*24.0*60.0))

	do i=1,sumecli
	 ysort(i)=y(i)
	end do
	  iswop=0
	  sort=.true.
	do while (sort)
	  swop=.false.
	do i=2,sumecli
	 if(ysort(i).lt.ysort(i-1)) then
	  yswop1=ysort(i)
	  yswop2=ysort(i-1)
	  ysort(i)=yswop2
	  ysort(i-1)=yswop1
	  swop=.true.
          iswop=iswop+1
	 end if
	end do
	if(.not.swop) sort=.false.
	end do

c	write(*,*) 'Number of swops ',iswop

c	do i=1,sumecli
c	 write(*,*) i,ysort(i),y(i)
c	end do

	do i=1,sumecli
	  cumul(i)=0.0
	 do j=1,sumecli
	   if(ysort(j).le.ysort(i)) cumul(i)=cumul(i)+1.0
	 end do
	  cumul(i)=cumul(i)/sumecli
	end do


	 
	 write(*,*) ' '
	 write(*,*) 'Eclipse statisics :'
	 write(*,*) ' '
	if(numecli.gt.0) then
	 write(*,*) 'number of eclipse periods:   ',sumecli
	 write(*,*) 'av # of eclipses per day:    ',sumecli/timeav
	 write(*,*) 'av length of eclipse (mins): ',averecli/sumecli
	else
	 write(*,*) 'No eclispses during this period'
	end if

!	write(*,*) '% of time cannot observe  ',avperlost


	left=0.05
        right=0.95
	bottom=0.05
        top=0.95

C hratio=ratio of plot heights  alpha=ratio of heights to space
!	hratio=0.3	
	hratio=0.5	
	alpha=0.0
	height1=(top-bottom)/((1+alpha)*(1+hratio)) 
	height2=hratio*height1
        spaceh=alpha*(height1+height2) 
C wratio=ratio of plot widths  beta=ratio of widths to space
	wratio=0.3	
	beta=0.08
	width1=(right-left)/((1+beta)*(1+wratio)) 
	width2=wratio*width1
        spacew=beta*(width1+width2)     


	ymaxplot=tsat

400	continue

	if(numecli.gt.0) then
	 write(*,*) ' '
	 write(*,*) 'maximum eclipse time (min):  ',ymax
	 write(*,*) 'occurred on day:             ' ,tymax
	 write(*,*) ' '
	 write(*,*) ' '
	 write(*,*) 'minimum eclipse time (min):  ',ymin
	 write(*,*) 'occurred on day:             ' ,tymin
	 write(*,*) ' '
	end if
	write(*,*) ' '

!	write(*,*) 'y-axis max now set to be (default=sat period) ',tsat
!	write(*,*) 'Do you want to change this y-axis max ? (1=yes)'
!	read(*,*) iansymax

	iansymax = 0

	if(iansymax.eq.1) then
	 write(*,*) 'what value for y-axis max (min) ?'
	 read(*,*) ymaxplot
	end if 

	 ymaxplot=yper(1)

	do i=2,numecli
	 if(yper(i).gt.ymaxplot) ymaxplot=yper(i)
	end do


	ymaxplot=ymaxplot*1.05


100	continue

!	 write(*,*) 'color or grey-scale plot ? (1=color)'
!	 read(*,*) icol

	  icol = 1

	if(numecli.eq.0) then
!	 write(*,*) 'ymaxplot: ',ymaxplot
	 ymaxplot = tsat
	end if

!	 write(*,*) 'ymaxplot: ',ymaxplot

	
!         call pgbegin(0,'?',1,1)
!         call pgbegin(0,plotf,1,1)

! this pgbegin was being used 2,2 may cause problems
!          call pgbegin(0,plotf,2,2)


	    in = 0 
	  

!	 call pgsch(0.6)
	 call pgsch(schtext*ascale)


	 xlabel(1)='Day Number ('//year//')'
         xlabel(2)='Eclipse Period (mins)'
	 ylabel(1)= 'Eclipse Period (mins)'
	 ylabel(2)= 'Cumulative Probability'
         ylabel(4)='Number'
	 ylabel(3)='True Anomaly (Degrees)'
	 ylabel(5)='Mean Anomaly (Degrees)'
	 title= 'Eclipse History for '//satname

         iblack =0  
         iwhite =1  
         ired   =2
         igreen =3
         iblue  =4
         icyan  =5
	 iyellow=7
         iorange=8
         iredmagenta=13
         idkgrey=14
         iltgrey=15

	if(icol.eq.1) then
	 icred   =ired
	 icgreen =igreen
	 icltgrey=iltgrey
	 icyellow=iyellow
!	 ictext=icyan
c	 ictext=iyellow
	 ictext=iwhite	 
	else
	 icred   =iwhite  ! white on screen black on paper
	 icgreen =iblack  ! black on screen white on paper
	 icltgrey= iltgrey! lt grey
	 icyellow=idkgrey !dark grey
	 ictext=iwhite
	end if


	lplot=left
        rplot=left+width1
	bplot=bottom+height2+spaceh
        tplot=bplot+height1


C  Eclipse Period or True Anomaly vs Day Number Plot 

	 do iopt = 0,1


!	  write(*,*) 'iopt: ',iopt

	 call pgsci(1)

	 if(iopt.eq.1) then
!	  write(*,*) 'call pgadvance'

! comment out 3-may-94
!	  call pgenv(t1,t2,-180.0,180.0,0,1)

	  in = in + 1

!	  call pgvport2(0.05,0.9,0.05,0.95,2,2,in,0.80,aspect)
	  call pgvport4(x1,x2,y1,y2,
     1    x1vp,x2vp,y1vp,y2vp,frac,2,2,in,0.80,aspect)

	  call pgwindow(t1,t2,-180.0,180.0)
	  call pgbox('ABCNST',0.0,0,'ABCNST',0.0,0)

!	  call pgadvance
	 else

! comment out 3-may-94
!	  call pgenv(t1,t2,0,ymaxplot,0,1)

!	   call pgvport(0.1,0.9,0.1,0.9)

	   in = in + 1

!	   call pgvport2(0.05,0.9,0.05,0.95,2,2,in,0.80,aspect)
	   call pgvport4(x1,x2,y1,y2,
     1     x1vp,x2vp,y1vp,y2vp,frac,2,2,in,0.80,aspect)

	   call pgwindow(t1,t2,0.0,ymaxplot)
	   call pgbox('ABCNST',0.0,0,'ABCNST',0.0,0)

	 end if


	  if(numecli.eq.0) then
	     call pgsci(icred)
	     xtext = 0.5*(t1+t2)
	     yheight = 0.7
            if(iopt.eq.1) then
	     ytext = -180.0 + yheight*360.0
	    else
	     ytext = yheight*ymaxplot
	    end if

	  call pgsch(1.7*ascale)
	  call pgptext(xtext,ytext,0.0,0.5,'No eclipses during this period')
	  call pgsch(schtext*ascale)

	   end if


!	  call pgvport(lplot,rplot,bplot,tplot)
!	 if(iopt.eq.0) then
!	  call pgwindow(t1,t2,0,ymaxplot)
!	 else
!	  call pgwindow(t1,t2,-180.0,180.0)
!	end if	 
!          call pgbox('bcnst',0,0,'bcnst',0,0)

	 if(iopt.eq.0) then
	  call pgsci(ictext)
	  call pglabel(xlabel(1),ylabel(1),title)
!	  call pgpoint(sumecli,x,y,0)
	  call pgsci(icgreen) ! green
	  tper2=2*tper
!	  call pgrect(t1,t2,tper2,ymaxplot)
	  call pgsci(icltgrey) ! lt grey
	  call pgrect(t1,t2,0.0,tper2)

	  call pgsci(icyellow) ! yellow
	 do i=1,sumecli	
	  call pgmove(x(i),y(i))
	  call pgdraw(x(i),ybatt(i))
	 end do

	  call pgsci(icltgrey) ! lt grey
	 do i=1,sumecli	
	  call pgmove(x(i),ybatt(i))
	  call pgdraw(x(i),yper(i))
	 end do

	  call pgsci(icred)	! red  
	 do i=1,sumecli	
	  call pgmove(x(i),0.0)
	  call pgdraw(x(i),y(i))
	 end do

	  call pgsci(1)

	 else
	  if(iopt.eq.1) then
	   call pgsci(ictext)
	   call pglabel(xlabel(1),ylabel(3),title)
c	   call pgpoint(sumecli,x,nustart2,0)
c	   call pgpoint(sumecli,x,nustop2,0)
	   call pgsci(icgreen) ! green
!	   call pgrect(t1,t2,-180.0,180.0)	  
	   call pgsci(icltgrey) ! light Grey
	   call pgrect(t1,t2,-nuper,nuper)
	   call pgsci(icred) ! red 
	  do i=1,sumecli
	   if(nu1(i).le.nu2(i)) then	
	    call pgmove(x(i),nu1(i))
	    call pgdraw(x(i),nu2(i))
	   else
	    call pgmove(x(i),nu1(i))
	    call pgdraw(x(i),180.0)	    
	    call pgmove(x(i),-180.0)
	    call pgdraw(x(i),nu2(i))
	   end if
	  end do	  
	   call pgsci(icyellow) ! yellow 
	  do i=1,sumecli
	   diff=nu3(i)-nu2(i)
	   if(trecharge.gt.0.0) then
	    if(diff.gt.-1.0) then	
	     call pgmove(x(i),nu2(i))
	     call pgdraw(x(i),nu3(i))
	    else
	     call pgmove(x(i),nu2(i))
	     call pgdraw(x(i),180.0)
	     call pgmove(x(i),-180.0)
	     call pgdraw(x(i),nu3(i))
	    end if
	   end if
	  end do
	 end if

	

C  Mean Anomaly vs Day Number Plot 

	  if(iopt.eq.2) then
	   call pglabel(xlabel(1),ylabel(5),title)
	   call pgsci(icgreen) ! green
	   call pgrect(t1,t2,-180.0,180.0)	  
	   call pgsci(icltgrey) ! light Grey
	   call pgrect(t1,t2,-mper,mper)
	   call pgsci(icred) ! red 
	  do i=1,sumecli
	   if(m1(i).le.m2(i)) then	
!	    call pgmove(x(i),m1(i))
!	    call pgdraw(x(i),m2(i))
	    dx=elength(i)/(24.0*60.0)
	    x1=x(i)-0.5*dx
	    x2=x(i)+0.5*dx
	    write(*,*) i,x(i),elength(i),dx
	    call pgrect(x1,x2,m1(i),m2(i))
	   else
	    call pgmove(x(i),m1(i))
	    call pgdraw(x(i),180.0)	    
	    call pgmove(x(i),-180.0)
	    call pgdraw(x(i),m2(i))
	   end if	
	  end do	  
	   call pgsci(icyellow) ! yellow 
	  do i=1,sumecli
	   diff=m3(i)-m2(i)
	   if(trecharge.gt.0.0) then
	    if(diff.gt.-1.0) then	
	     call pgmove(x(i),m2(i))
	     call pgdraw(x(i),m3(i))
	    else
	     call pgmove(x(i),m2(i))
	     call pgdraw(x(i),180.0)
	     call pgmove(x(i),-180.0)
	     call pgdraw(x(i),m3(i))
	    end if
	   end if
	  end do
	 end if

	  call pgsci(1)

	end if

	end do !do iopt = 0,1

	 if(iopt.eq.0) then
	  call pgwindow(t1,t2,0,ymaxplot)
	 else
	  call pgwindow(t1,t2,-180.0,180.0)
	end if	 
          call pgbox('bcnst',0,0,'bcnst',0,0)


	 lplot=left+width1+spacew
         rplot=lplot+width2 
	 bplot=bottom+height2+spaceh
         tplot=bplot+height1

C	write(*,*) 'min, max eclipse periods(hrs) ',ymin,ymax

       

C	write(*,*) 'lplot,rplot,bplot,tplot ',lplot,rplot,bplot,tplot

C   Cumulative Probability vs Viewperiod Plot


!	 call pgvport(lplot,rplot,bplot,tplot)
!	 call pgwindow(0.0,ymax,0.0,1.0)
!        call pgbox('bcnst',0,0,'bcnst',0,0)


!	 call pglabel(xlabel(2),ylabel(2),' ')
!	 call pgpoint(sumecli,ysort,cumul,0)
!	 call pgsci(2)
!	 call pgline(sumecli,ysort,cumul)
!	 call pgsci(1)


	lplot=left
	rplot=lplot+width1
	bplot=bottom
	tplot=bottom+height2



c	text(1)='Satellite       : '//satname

	text(3)='Range of days:'
	write(text(4),'(f9.3)')  t1
	write(text(5),'(f9.3)') t2
	text(6)='Number of eclipses:'
        write(text(7),'(i5)') sumecli
	text(8)='Av # of eclipses a day '
        write(text(9),'(f7.3)') sumecli/timeav
	text(10)='Av length of eclipse (mins) '
	if(numecli.eq.0) then
        write(text(11),'(f7.3)') 0.0
	else
        write(text(11),'(f7.3)') averecli/sumecli
	end if

	text(12)='total number of eclipses   '
        write(text(13),'(i5)') numecli

	text(14)='% of time cannot observe  '
        write(text(15),'(f7.3)') avperlost
	text(16)='Max eclipse length (min)'
	write(text(17),'(f7.3)') ymax
	text(18)='Min eclipse length (min) '
	write(text(19),'(f7.3)') ymin
	text(20)='Perigee Ops: time lost(mins)'
	write(text(21),'(f7.3)') 2*tper	
	text(22)='Perigee Ops: true anomaly cutoff (deg)'
	write(text(23),'(f7.3)') nuper
	text(24)='Recovery time (in units of eclipse time)'
	write(text(25),'(f7.3)') trecharge
	text(26)='Satellite Period (hrs)'
	write(text(27),'(f7.3)') tsat/60.0

	text(28)='Orbit Elements at Ref Epoch:'
	text(29)='semi-major axis (km)'
	write(text(30),'(f11.3)') a	
	text(31)='inclination (deg)'
	write(text(32),'(f7.3)') inc	
	text(33)='eccentricity'
	write(text(34),'(f7.3)') e
	text(35)='RA of asc node (deg)'
	write(text(36),'(f7.3)') ran
	text(37)='Arg of perigee (deg)'
	write(text(38),'(f7.3)') aop
	text(39)='Mean anomaly(deg)'
	write(text(40),'(f7.3)') man

!	schtext=0.4
!	dy=0.012
!	xtext=left+width1+spacew
!	dy=0.015

	dx=0.27
	xtext1=0.05
	xtext2=xtext1+dx
	xtext3=xtext1+2.0*dx
	xtext4=xtext1+2.8*dx

!	schtext=0.52


!	dy=0.02
	dy=0.04


	ytext0=bottom+height2-0.09

	ytext0=0.95

!	 call pgadvance
!	 call pgenv(0.0,ymax,0.0,1.0,0,-2)


! comment out 3-May-94
!	 call pgenv(0.0,1.0,0.0,1.0,0,-2)

!	 call pgvport(0.1,0.9,0.1,0.9)

	 in = in + 1

!	 call pgvport2(0.05,0.9,0.05,0.95,2,2,in,0.80,aspect)
	 call pgvport4(x1,x2,y1,y2,
     1   x1vp,x2vp,y1vp,y2vp,frac,2,2,in,0.80,aspect)


	 call pgwindow(0.0,1.0,0.0,1.0)


				
!	  call pgvport(0.0,1.0,0.0,1.0)
!	  call pgwindow(0.0,1.0,0.0,1.0)

	 call pgsch(schtext*ascale)
	  
	 ytext=ytext0
	
!	do i=3,40
!C 	write(*,*) 'xtext,ytext ',xtext,ytext
!	 if(i.le.15) xtextplot=xtext1
!	 if((i.gt.15).and.(i.le.27)) xtextplot=xtext2
!	 if(i.gt.27) xtextplot=xtext3
!	 if(i.eq.16) ytextplot=ytext0
!	 if(i.eq.28) ytextplot=ytext0
!	 call pgtext(xtextplot,ytextplot,text(i))
!C	 write(*,'(1x,a)') text(i)
!	 ytextplot=ytextplot-dy
!	end do

	
	xtext=0.0

	call pgsci(ictext)

	do i=3,40
	 if(i.ge.28) xtext=0.5
	 if(i.eq.28) ytext=ytext0
	 if(i.ne.12.and.i.ne.13) then
	  call pgtext(xtext,ytext,text(i))
	  ytext=ytext-dy
	 end if
	end do


!          xtext=xtext4
!          ytext=ytext0

!	   call pgsch(2.0)
	  call pgsch(schtext*ascale)

	
	 use=.false.

	 if(use) then

	   call pgsci(icred)
	   call pgpoint(1,xtext,ytext,16)
           ytext=ytext-dy
	   call pgsci(icyellow)
	   call pgpoint(1,xtext,ytext,16)
           ytext=ytext-dy
	   call pgsci(icltgrey)
	   call pgpoint(1,xtext,ytext,16)
           ytext=ytext-dy
	   call pgsci(icgreen)
	   call pgpoint(1,xtext,ytext,16)
           ytext=ytext-dy
	   call pgsci(1)

!	  call pgsch(schtext*ascale)
!          xtext=xtext4+0.02
!          ytext=ytext0

	   xtext=xtext+0.04

	   call pgsci(1)
	   call pgtext(xtext,ytext,'Eclipse')
           ytext=ytext-dy
	   call pgsci(1)
	   call pgtext(xtext,ytext,'Recovery')
           ytext=ytext-dy
	   call pgsci(1)
	   call pgtext(xtext,ytext,'Perigee Operations')
           ytext=ytext-dy
	   call pgsci(1)
	   call pgtext(xtext,ytext,'Observations')
           ytext=ytext-dy
	   call pgsci(1)

	end if


	 call pgiden

!	 write(*,*) 'Do you want histogram of eclipses ? (1=yes)'
!	 read(*,*) ians

	 if(numecli.eq.0) then
	   ians = 0
	 else
	   ians = 1
	 end if

!	 call pgadvance

	if(ians.eq.1) then
!	 write(*,*) 'how many bins for histogram ?'
!	 read(*,*) ibin
	 ibin = 20
!	  call pgsch(1.0)
	 call pgsch(schtext*ascale)

	  call pgsci(1)

	     yhistmin=0.9*ymin
	     yhistmax=1.1*ymax

	  if(yhistmax.eq.0.0) then
	     yhistmin=  0.0
	     yhistmax=  tsat
	  end if


!	  call pghist(sumecli,y,yhistmin,yhistmax,ibin,0)

	   in = in + 1

!	  call pgvport2(0.05,0.9,0.05,0.95,2,2,in,0.80,aspect)
	  call pgvport4(x1,x2,y1,y2,
     1     x1vp,x2vp,y1vp,y2vp,frac,2,2,in,0.80,aspect)

	   xh1 = yhistmin
	   xh2 = yhistmax
	   yh1 = 0.0
	   yh2 = float(sumecli)+1.0
	  call pgwindow(xh1,xh2,yh1,yh2)
	  call pgbox('BCNST',0.0,0,'BCNST',0,0)

          call pgsci(iorange)	  
	  call pghist(sumecli,y,yhistmin,yhistmax,ibin,1)
          call pgsci(ictext)	  
	  call pglabel(xlabel(2),ylabel(4),'Eclipse Period Histogram')          

!	  call pgvport(0.0,1.0,0.0,1.0)

!	  in = in + 1
!	  call pgvport2(0.05,0.9,0.05,0.95,2,2,in,0.80,aspect)
!	  call pgwindow(0.0,1.0,0.0,1.0)

!	 call pgsch(0.6)
	 call pgsch(schtext*ascale)


          xtext=0.15
          ytext=0.85
!            dy=0.015
             dy=0.030

!	 do i=3,17
!	  call pgtext(xtext,ytext,text(i))
!           ytext=ytext-dy
!	 end do


	  call pgiden

	end if

!	 write(*,*) 'ellipse plot of eclipse for a given day? (1=yes)'
!	 read(*,*) ians2

	 ians2 = 0

	if(ians2.eq.1) then

	 write(*,*) 'what day number ?'
	 read(*,*) daynum

	do i=1,numecli
	 if(i.eq.1) then
	   diff=abs(daynum-etime(i))
           nu1plot=nustart(i)
           nu2plot=nustop(i)
           nu3plot=nubatt(i)
	   daynumplot=etime(i)
	 else
	  if(abs(daynum-etime(i)).lt.diff) then
	   diff=abs(daynum-etime(i))
	   daynumplot=etime(i)
           nu1plot=nustart(i)
           nu2plot=nustop(i)
           nu3plot=nubatt(i)
	  end if
	 end if
	end do

!	if(nu1plot.lt.0.0) nu1plot=nu1plot+360.0
!	if(nu2plot.lt.0.0) nu2plot=nu2plot+360.0
!	if(nu3plot.lt.0.0) nu3plot=nu3plot+360.0

	if(nu2plot.lt.nu1plot) nu2plot=nu2plot+360.0
	if(nu3plot.lt.nu1plot) nu3plot=nu3plot+360.0

	write(*,*) 'nu1plot,nu2plot,nu3plot ',nu1plot,nu2plot,nu3plot

	write(*,*) 'eclipse closest to day number requested centered at '
	write(*,*) daynumplot
	 
	
!	  call pgsch(1.0)
	 call pgsch(schtext*ascale)


!	  call pgadvance
!	  call pgvport(0.0,1.0,0.0,1.0)

	  in = in + 1

!	  call pgvport2(0.05,0.9,0.05,0.95,2,2,in,0.80,aspect)
	  call pgvport4(x1,x2,y1,y2,
     1    x1vp,x2vp,y1vp,y2vp,frac,2,2,in,0.80,aspect)

	  call pgwindow(-1.6,1.6,-1.6,1.6)
	  call pgbox('a',0.0,0,'a',0.0,0)
	
	  inumplot=1000

	  do i=1,inumplot

	    ang1=-180.0+540.0*float(i-1)/float(inumplot)
	    ang2=-180.0+540.0*float(i)/float(inumplot)

!	    dnu=540.0/float(inumplot)

	    write(*,*) 'ang1, ang2 ',ang1, ang2

	   xplot(1)=0.0 	    
	   yplot(1)=0.0	   
	   xplot2(1)=0.0 	    
	   yplot2(1)=0.0

	   r2=(1.0-e*e)
	   r2=r2/(1.0+e*cos(ang1*dr))

	   r3=(1.0-e*e)
	   r3=r3/(1.0+e*cos(ang2*dr))

!	   r2=(1.0-e*e)/(1.0+e*cos(ang1*dr))
!	   r3=(1.0-e*e)/(1.0+e*cos(ang2*dr))

!	  write(*,*) 'r2,r3 ',r2,r3
		
	
	   rx=1.2

 	   xplot(2)= -1.0*r2*cos(ang1*dr) 	    
	   yplot(2)= -1.0*r2*sin(ang1*dr) 	    	    	   
	   xplot(3)= -1.0*r3*cos(ang2*dr) 	    
	   yplot(3)= -1.0*r3*sin(ang2*dr)


 	   xplot2(2)= -1.0*rx*r2*cos(ang1*dr) 	    
	   yplot2(2)= -1.0*rx*r2*sin(ang1*dr) 	    	   	  
	   xplot2(3)= -1.0*rx*r3*cos(ang2*dr) 	    
	   yplot2(3)= -1.0*rx*r3*sin(ang2*dr)

	  do j=1,3
	   xplot(j)=xplot(j)-e
	   xplot2(j)=xplot2(j)-e
!	   write(*,*) 'j,xplot(j), yplot(j) ',j,xplot(j),yplot(j)
!	   write(*,*) 'j,xplot2(j), yplot2(j) ',j,xplot2(j),yplot2(j)
	  end do

 	   xplot2(1)= xplot(2) 	    
	   yplot2(1)= yplot(2)
	   xplot2(4)= xplot(3)	    
	   yplot2(4)= yplot(3)
 	    	   	   

	   icolor=igreen
	   icolor2=igreen

	  if(abs(ang1).le.nuper) icolor=iltgrey

	  if((ang1.ge.nu1plot).and.(ang1.le.nu2plot)) then
	   icolor2=ired
	  end if

	  if((ang1.gt.nu2plot).and.(ang1.le.nu3plot)) then
	   icolor2=iyellow
	  end if


	 if(ang1.le.180.0) then
	   call pgsci(iccolor)
	  if(abs(ang1).le.nuper) then 
	   call pgpoly(4,xplot2,yplot2)
	  else
	   call pgpoly(3,xplot,yplot)
	  end if
	 end if

	 if(icolor2.ne.igreen) then
	   call pgsci(iccolor2)
	   call pgpoly(3,xplot,yplot)
	 end if


	end do

	 call pgsci(1)	    	   



	  call pgiden

	end if




!	 call pgend


!	write(*,*) 'options: '
!	write(*,*) '0 = end program'
!	write(*,*) '1 = use another plotting device'
!	write(*,*) '2 = re-plot with different time range'
!	write(*,*) '3 = plot different data set '
!	write(*,*) '4 = plot with different y max '
	if(iopt.eq.0) then
!	write(*,*) '5 = change from eclipse time to true anomaly '
!	write(*,*) '6 = change from eclipse time to Mean anomaly '
	end if
	if(iopt.eq.1) then
!	write(*,*) '5 = change from true anomaly change from eclipse time'
!	write(*,*) '6 = change from true anomaly change from Mean anomaly'
	end if	
	if(iopt.eq.2) then
!	write(*,*) '5 = change from Mean anomaly change from eclipse time'
!	write(*,*) '6 = change from Mean anomaly change from true anomaly'
	end if
!	write(*,*) '7 = change pergiee and re-charge times '

!	write(*,*) 'which option ?'
!	read(*,*) iopt2

	 iopt2 = 0

	if(iopt2.eq.1) goto 100
	if(iopt2.eq.2) goto 200
	if(iopt2.eq.3) goto 300
	if(iopt2.eq.4) goto 400
	if(iopt2.eq.7) goto 700
	if((iopt2.eq.5)) then
	 if(iopt.eq.0) then
	  iopt=1
          goto 100
	 end if
	 if(iopt.eq.1) then
	  iopt=0
          goto 100
	 end if
	 if(iopt.eq.2) then
	  iopt=0
          goto 100
	 end if
	end if
	if((iopt2.eq.6)) then
	 if(iopt.eq.0) then
	  iopt=2
          goto 100
	 end if
	 if(iopt.eq.1) then
	  iopt=2
          goto 100
	 end if
	 if(iopt.eq.2) then
	  iopt=1
          goto 100
	 end if
	end if



      return
  999 write(*,*) 'ERR I/O'
      return 
      end






