
C*SRCUP
C+
      LOGICAL FUNCTION SRCUP(X,S)
      DOUBLE PRECISION X(3), S(3)
C
C Determine if source in (unit) direction S is VISIBLE to
C satellite in direction X.  Vectors measured from center of
C earth.
C-----------------------------------------------------------------------
C.    IMPLICIT NONE
      DOUBLE PRECISION  RE,GM,HJ2
      COMMON /EARTH/ RE,GM,HJ2
C
C       Source VISIBLE if satellite is in front of plane perpendicular
C       to source vector passing through earth.  (This assumes orbit is
C       above earth!)
C
      DOT = X(1)*S(1) + X(2)*S(2) + X(3)*S(3)
      IF (DOT.GT.0.) THEN
          SRCUP = .TRUE.
C
C       If satellite behind plane, source is still VISIBLE if satellite
C       is not shadowed by earth (|X x S| > earth radius).
C

! domain errors with following line:
!     ELSE IF (SQRT(X(1)*X(1)+X(2)*X(2)+X(3)*X(3) - DOT*DOT) .GT. RE)
! replace with:         DWM 7-Dec-94

      ELSE IF ((X(1)*X(1)+X(2)*X(2)+X(3)*X(3)) .GT. ((RE*RE)+(DOT*DOT))) 
     1  THEN
          SRCUP = .TRUE.
      ELSE
          SRCUP = .FALSE.
      END IF
      END
