
	subroutine SUN(jd,ra,dec,lamda,beta,ms,rs)

C given Julian date returns ra and dec of the sun
C ecliptic longitude, latitude and mean anomaly

	double precision jd,jd1980,lae,lop,e,r,numd
	double precision ns,ms,lamda,beta,nus
	double precision ra,dec,pi,rs,c,ts
	integer imethod

! set imethod = 0 if you want 'old' way to calculate lamda
! set imethod = 1 if you want 'new' way to calculate lamda
! 'old' method seems to work OK    DWM 7-feb-92
!  still need to check new method

! new method seems to work and is more accurate than old method
! DWM 22-mar-93

	imethod = 1	

	pi=3.141592654d0
	c=2.99792458d8

C sun's orbital elements at epoch 1980.0

	lae=278.833540d0
	lop=282.596403d0
	  e=0.016718d0
	  r=1.495985d11

	call JUD(1,1,1980,0,0,0.0d0,jd1980)

 	numd=jd-jd1980+1.0d0

	ns=(360.0d0/365.2422d0)*numd
	ns=ns+360.0d0
	ns=dmod(ns,360.0d0)

	ms=ns+lae-lop
	ms=ms+360.0d0
	ms=dmod(ms,360.0d0)


	if(imethod.eq.0) then
! old method
	 es=(360.0d0/pi)*e*dsin(ms*pi/180.0d0)
	 lamda=ns+es+lae
	else
! new method
	 call KEP(ms,e,1.0d-12,nus)
	 lamda=nus+lop
	end if

	lamda=lamda+360.0d0
	lamda=dmod(lamda,360.0d0)

	beta=0.0d0
	call cnvrt1(ra,dec,lamda,beta,-1)

! Error is calculating distance to sun
! nus needs to be in radians DWM 13-dec-91 !!!

	rs=r*(1-e*e)/(1+e*dcos(pi*nus/180.0d0))

! correct for light travel time. DWM 22-mar-93

	ts=(rs/c)/(24.0d0*60.0d0*60.0d0)

!	write(*,*) 'ts is ',ts

 	numd=jd-jd1980+1.0d0-ts

	ns=(360.0d0/365.2422d0)*numd
	ns=ns+360.0d0
	ns=dmod(ns,360.0d0)

	ms=ns+lae-lop
	ms=ms+360.0d0
	ms=dmod(ms,360.0d0)


	if(imethod.eq.0) then
! old method
	 es=(360.0d0/pi)*e*dsin(ms*pi/180.0d0)
	 lamda=ns+es+lae
	else
! new method
	 call KEP(ms,e,1.0d-12,nus)
	 lamda=nus+lop
	end if

	lamda=lamda+360.0d0
	lamda=dmod(lamda,360.0d0)

	beta=0.0d0
	call cnvrt1(ra,dec,lamda,beta,-1)

! Error is calculating distance to sun
! nus needs to be in radians DWM 13-dec-91 !!!

	rs=r*(1-e*e)/(1+e*dcos(pi*nus/180.0d0))


!	write(*,*) 'SUN: numd,ns,ms '
!	write(*,*) numd,ns,ms
!	write(*,*) 'SUN: nus,lamda,rs'
!	write(*,*) nus,lamda,rs
!	write(*,*) 'SUN: ra,dec'
!	write(*,*) ra,dec

	return
	end
