
      SUBROUTINE UVMX(X,Y,Z,AEIOWM,COSRA,SINRA,COSDEC,
     1      SINDEC,STATYP,UMX,VMX)
      IMPLICIT NONE
      REAL*8 X,Y,Z,AEIOWM(6),COSRA,SINRA,COSDEC,SINDEC,COSI,SINI,
     1      COSO,SINO,SINOMA,COSTH,E,E2,EM,COSP,SINP,A,TANFI,COSFI,
     2      SINFI,BE
      REAL UMX,VMX
      INTEGER STATYP
      IF (STATYP.EQ.2) THEN
            A = (1D0+AEIOWM(2))*AEIOWM(1)       ! Apoapsis; ass. orbit circluar
            SINI = DSIN(AEIOWM(3))      ! Inclination
            COSI = DCOS(AEIOWM(3))
            SINO = DSIN(AEIOWM(4))      ! Ascending Node
            COSO = DCOS(AEIOWM(4))
            SINOMA = SINO*COSRA - COSO*SINRA    ! (O-RA) = Viewing angle + 90
            COSTH = SINI*COSDEC*SINOMA + COSI*SINDEC    ! TH = Angle between
            E = DSQRT(1D0 - COSTH*COSTH)        ! source and orbital plane
            IF (E.LE.1D-2) THEN                 ! vectors  (E = SINTH =
                UMX = A                         ! eccentricity of ellipse
                VMX = A                         ! in UV plane)
                RETURN
            END IF
            COSP = (-SINI*SINDEC*SINOMA + COSI*COSDEC)/E        ! P = Angle of
            SINP = DSQRT(1D0-COSP*COSP)         ! orientation of ellipse in
            IF (E.GT.0.99) THEN                 ! UV plane
                UMX = A*COSP
                VMX = A*SINP
                RETURN
            END IF
            E2 = E*E
            EM = DSQRT(1D0-E2)
            TANFI = E2*SINP*COSP/(1D0-E2*SINP*SINP)     ! FI is position
            COSFI = 1D0/DSQRT(1D0+TANFI*TANFI)  ! in orbit where max U (or
            SINFI = DSQRT(1D0-COSFI*COSFI)      ! max V) occurs
            UMX = A*EM*COSFI/DSQRT(1D0-E2*(COSFI*COSP+SINFI*SINP)**2)
            TANFI = (1D0-E2*COSP*COSP)/(E2*SINP*COSP)
            COSFI = 1D0/DSQRT(1D0+TANFI*TANFI)
            SINFI = DSQRT(1D0-COSFI*COSFI)
            VMX = A*EM*SINFI/DSQRT(1D0-E2*(COSFI*COSP+SINFI*SINP)**2)
            RETURN
      ELSE IF (STATYP.EQ.1) THEN
            BE = DSQRT(X*X+Y*Y)
            UMX = BE
            VMX = DABS(BE*SINDEC) + DABS(Z*COSDEC)
            RETURN
      ELSE
            CALL ERROR('ILLEGAL STATION TYPE')
      END IF
      END
